#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de recoger las letras que caen para formar una palabra. 
#
#
#


import wx
import codecs
import sys
import os
import random
import time



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [6,0,u'Gontzal Uriarte',u'Recoger las letras que caen'] )
        self.img=""
        self.Imagen=""
        self.contador=0
        
        self.posicionesx=[310,340,370,400,430,460,490,510,540,570,600,630,660,690,720,750,780]
        # tl nos indicara [0] la letra, [1] estado, [2] posicion x, [3] posicion y
        self.tl=[]
        self.palabra=""
        self.palabraconstruida=""
     
        self.chavalx=350
        self.completada=False
        self.primera=True


    def PaintJuego6(self,event):
        dc=wx.PaintDC(self)
        dc.DrawBitmap(self.img,10,50,False)
        dc.SetPen(wx.Pen('Green', 15))
        dc.DrawRectangle(300,50,500,350)
        
        dc.SetPen(wx.Pen('Brown', 5))
        dc.DrawLine(self.chavalx-20,360,self.chavalx-15,380)
        dc.DrawLine(self.chavalx-15,380,self.chavalx+15,380)
        dc.DrawLine(self.chavalx+15,380,self.chavalx+20,360)
        dc.DrawLine(self.chavalx,380,self.chavalx,450)
        dc.DrawLine(self.chavalx,450,20,450)
        dc.DrawLine(20,250,20,450)
    
        dc.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))
        dc.SetTextForeground("blue")   
        
        for i in range(0,len(self.palabra)):
            if self.tl[i][1]==1:
                dc.DrawText(self.P.maymin(self.tl[i][0]),self.tl[i][2],self.tl[i][3])
        dc.SetTextForeground("white")        
        dc.DrawText(self.P.maymin(self.palabraconstruida),15,200)
        event.Skip()
     
    def MotorJuego6(self,event):
        tecla = event.GetKeyCode()
        if tecla==wx.WXK_LEFT and self.chavalx>300:
             self.chavalx-=10
                
                
        if tecla==wx.WXK_RIGHT and self.chavalx<790:
            self.chavalx+=10
            
        if tecla==wx.WXK_BACK and not self.completada:
            if len(self.palabraconstruida)>0:
                ultimaletra=self.palabraconstruida[len(self.palabraconstruida)-1]
                self.palabraconstruida=self.palabraconstruida[0:-1:]
                for i in range(0,len(self.tl)):
                    if self.tl[i][0]==ultimaletra and self.tl[i][1]==0:
                        self.tl[i][1]=1
                        break

        event.Skip()
        
    def MainJuego6(self,event):
 
        self.inicializar()
        self.padre.tiempo.Start(50)
        self.Refresh()        
        self.SetFocus()
        event.Skip()
        
    def Apoyo6(self,event):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<=1:            
            self.sonido.habla(self.palabra)
        
        event.Skip()
        
    def Terminar6(self,event=None):
        self.padre.tiempo.Stop()
        self.Unbind (wx.EVT_TIMER)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind (wx.EVT_PAINT)
        self.Unbind (wx.EVT_KEY_DOWN )
        self.Unbind (wx.EVT_MOTION)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        self.padre.pantalla=1 #pantalla de ejercicios
        self.Hide()
        self.padre.Panel_ejercicios.Show()
        
        
        

    def Ayuda6(self,event):
        diesto='Atrapa las letras que caen para construir la palabra '+self.palabra
        self.sonido.habla(diesto)
        self.SetFocus()
    
    
    def ontimer(self,event):    
        for i in range(0,len(self.palabra)):
            if self.tl[i][3]<350:
                self.tl[i][3]+=random.randint(0,10)
            else:
                self.tl[i][3]=50
        
            if self.chavalx-20<self.tl[i][2]+10 and self.chavalx+20>self.tl[i][2]+10 and self.tl[i][3]>340 and self.tl[i][3]<370:
                if self.tl[i][1]==1:
                    self.palabraconstruida+=self.tl[i][0]
                    self.tl[i][1]=0
                    self.padre.sonido(5)
                    
        if self.palabraconstruida==self.palabra:
            self.padre.sonido(22)
            self.completada=True
            self.P.puntos+=self.P.incremento
            self.padre.Panel_control.progreso.SetValue(self.P.puntos)
            self.padre.tiempo.Stop()
            self.P.puntosjuegos[6]+=1
        
        self.Refresh()
        event.Skip()
        
        
    def Juego(self):
        self.Show()
        self.SetBackgroundColour('Blue')
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego6)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda6)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar6)
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo6)
        self.Bind(wx.EVT_PAINT, self.PaintJuego6)
        self.Bind (wx.EVT_KEY_DOWN ,self.MotorJuego6)
        self.Bind (wx.EVT_MOTION,lambda s: self.SetFocus())
        self.padre.sonido(4)
        self.SetFocus()
        self.inicializar()

    def inicializar(self):
        self.palabra=random.choice(self.P.tabla)
        self.img = wx.Image((self.direccion+u"fotos//"+self.palabra+u".png"), wx.BITMAP_TYPE_ANY)
        self.img= self.img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.img= wx.BitmapFromImage(self.img)            
        self.palabra= self.palabra.replace("-","")
        self.palabraconstruida=""
        self.tl=[]
        self.completada=False
        self.posicionesx=[310,340,370,400,430,460,490,510,540,570,600,630,660,690,720,750,780]
        for i in range(0,len(self.palabra)):
            self.tl.append([self.palabra[i],1,0,50])    
            lugarx=random.choice(self.posicionesx)
            self.tl[i][2]=lugarx
            self.posicionesx.remove(lugarx)
            
        self.Refresh()
        
        # Activar el evento del reloj
        self.padre.tiempo.Start(50)
        



