#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de recoger las letras esparcidas sin que te pille la rana
#
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [8,0,u'Gontzal Uriarte',u'Recoger letras para formar palabra'] )
        self.bloque=""
        self.Imagen=""
        self.palabra=""
        self.nivel1=[]
        self.pantalla=[]
        self.palabralista=[]
        self.palabraconstruida=""        
        self.tomado=False
        self.archivo=""
        self.fallos=0
        self.yox=3
        self.yoy=1
        self.objetivox=1
        self.objetivoy=1
        self.completada=False
        self.primera=True
        self.antx=0
        self.anty=0
        self.malox=13
        self.maloy=5
        self.camino=""
        self.palabratomada=0
     

    def PaintJuego8(self,event):
        dc=wx.PaintDC(self)
        for i in range(0,len(self.pantalla)):
            for j in range(0,len(self.pantalla[0])):
                if type(self.pantalla[i][j]) is int:
                    if self.pantalla[i][j]==1:
                        dc.DrawBitmap(self.bloque,10+30*j,10+30*i,False)
                elif type (self.pantalla[i][j]) is unicode:
                    dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
                    dc.DrawText(self.P.maymin(self.pantalla[i][j]),10+10+30*j,10+5+30*i)
        dc.SetPen(wx.Pen('Black',5))
        dc.DrawRectangle(220,380,500,100)
        dc.SetFont(wx.Font(50, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.DrawText(self.P.maymin(self.palabraconstruida),380+len(self.palabraconstruida)*-10,400)
        dc.DrawBitmap(self.Img_yo,10+30*self.yox,10+30*self.yoy,False)
        dc.DrawBitmap(self.Img_malo,10+30*self.malox,10+30*self.maloy,False)        
        dc.DrawBitmap(self.Img_palabra,100,380,False)
        
        event.Skip()
     
    def MotorJuego8(self,event):
        tecla = event.GetKeyCode()
        if tecla==wx.WXK_LEFT and not self.completada:
            if self.pantalla[self.yoy][self.yox-1]!=1:
                self.antx=self.yox
                self.anty=self.yoy
                self.yox-=1
                self.Refresh()
         
        if tecla==wx.WXK_RIGHT and not self.completada :
            if self.pantalla[self.yoy][self.yox+1]!=1:
                self.antx=self.yox
                self.anty=self.yoy
                self.yox+=1
                self.Refresh()
            
        if tecla==wx.WXK_UP and not self.completada:
            if self.pantalla[self.yoy-1][self.yox]!=1:
                self.antx=self.yox
                self.anty=self.yoy
                self.yoy-=1
                self.Refresh()
        
        if tecla==wx.WXK_DOWN and not self.completada:
            if self.pantalla[self.yoy+1][self.yox]!=1:
                self.antx=self.yox
                self.anty=self.yoy
                self.yoy+=1
                self.Refresh()
        
        if tecla==wx.WXK_CONTROL and not self.completada:#tecla para coger letras
            if self.pantalla[self.yoy][self.yox]!=0:
                self.palabraconstruida=self.palabraconstruida+self.pantalla[self.yoy][self.yox]
                self.pantalla[self.yoy][self.yox]=0 
                self.padre.sonido(5)
                self.Refresh()
        
        if tecla==wx.WXK_BACK and not self.completada:# tecla back para borrar las equivocadas.
            
            if len(self.palabraconstruida)>0:
                self.padre.sonido(5)
                letra=self.palabraconstruida[-1::]
                self.palabraconstruida=self.palabraconstruida[:-1:]
                colocado=False
                while not colocado:
                    linea=random.randint (0,len(self.pantalla)-1)
                    colum=random.randint (0,len(self.pantalla[0])-1)
                    if self.pantalla[linea][colum]==0:
                        colocado=True
                        self.pantalla[linea][colum]=letra
                self.Refresh()
        
                
        
        if self.maloy==self.yoy and self.malox==self.yox:
            self.padre.sonido(1)
            self.maloy=5
            self.malox=13
            self.yox=1
            self.yoy=1
            self.Refresh()
                        
        
        event.Skip()
        
    def MainJuego8(self,event):
        self.inicializa()
        self.Refresh()
        self.SetFocus()
        event.Skip()
        
    def Apoyo8(self,event):
        
        event.Skip()
        
    def Terminar8(self,event=None):
        self.padre.tiempo.Stop()
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_KEY_DOWN)
        self.Unbind (wx.EVT_MOTION)
        
        self.padre.pantalla=1 #pantalla de ejercicios
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        self.padre.Panel_ejercicios.Show()
        self.Hide()


    def Ayuda8(self,event):
        self.sonido.habla(u'Muevete con las teclas e intenta capturar las letras en orden para formar la palabra.')
        self.sonido.habla(u'Las letras se atrapan con control.')
        event.Skip()
        
    def ontimer(self,event):   
        
        if not self.completada:
            if self.pantalla[self.yoy][self.yox]==20:
                self.objetivox=1
                self.objetivoy=1
            elif self.pantalla[self.yoy][self.yox]==30:
                self.objetivox=1
                self.objetivoy=12
            elif self.pantalla[self.yoy][self.yox]==0:
                self.objetivox=self.yox
                self.objetivoy=self.yoy
            
            
            if self.malox>self.objetivox:
                if self.pantalla[self.maloy][self.malox-1]==0:
                    self.malox-=1
            elif self.malox<self.objetivox:
                if self.pantalla[self.maloy][self.malox+1]==0:
                    self.malox+=1
            
            if self.maloy>self.objetivoy:
                if self.pantalla[self.maloy-1][self.malox]==0:
                    self.maloy-=1
            elif self.maloy<self.objetivoy:
                if self.pantalla[self.maloy+1][self.malox]==0:
                    self.maloy+=1
                    
            
            if self.maloy==self.yoy and self.malox==self.yox:
                self.padre.sonido(1)
                self.maloy=5
                self.malox=13
                self.yox=1
                self.yoy=1
                self.fallos+=1
                
            if len(self.palabralista)==len(self.palabraconstruida):
                if ''.join(self.palabralista)==self.palabraconstruida:
                    self.padre.sonido(22)
                    self.completada=True
                    self.yoy=1
                    self.yox=1
                    self.malox=14
                    self.maloy=1
                    self.objetivox=14
                    self.objetivoy=1
                    self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                    self.fallos=0
                    self.padre.tiempo.Stop()
                    self.P.puntosjuegos[8]+=1
                    
                elif self.palabraconstruida!=''.join(self.palabralista):
                    self.padre.sonido(1)
                    self.yoy=1
                    self.yox=1
                    self.malox=14
                    self.maloy=1
                    self.fallos=self.fallos+1
                    self.palabraconstruida=""
                    for i in range (0,len(self.palabralista)):
                        colocado=False
                        while not colocado:
                            linea=random.randint (0,len(self.pantalla)-1)
                            colum=random.randint (0,len(self.pantalla[0])-1)
                            if self.pantalla[linea][colum]==0:
                                colocado=True
                                self.pantalla[linea][colum]=self.palabralista[i]
                
                    
                    
        self.Refresh()
        
                
        event.Skip()
        
        
    def Juego(self):
        self.SetBackgroundColour('Blue')
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego8)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda8)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar8)
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo8)
        self.Bind(wx.EVT_PAINT, self.PaintJuego8)
        self.Bind (wx.EVT_MOTION, lambda s: self.SetFocus())
        self.Bind (wx.EVT_KEY_DOWN ,self.MotorJuego8)
        
        self.padre.sonido(4)
        self.Show()
        self.inicializa()
        

    def inicializa(self):
        
        a=20 #mostrando palabra
        b=30 #dibujo
        n=-1 #nada 
        self.nivel1=  [[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1],
                       [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]]
        

        self.pantalla=copy.deepcopy(self.nivel1)
        # sacaremos una palabra y le modificamos algunas letras
        self.palabra=random.choice(self.P.tabla)
        self.palabraconstruida=""
        self.archivo=self.palabra;
        self.palabra=self.palabra.replace('-','')
        self.palabralista=list(self.palabra)
        for i in range (0,len(self.palabralista)):
            colocado=False
            while not colocado:
                linea=random.randint (0,len(self.pantalla)-1)
                colum=random.randint (0,len(self.pantalla[0])-1)
                if self.pantalla[linea][colum]==0:
                    colocado=True
                    self.pantalla[linea][colum]=self.palabralista[i]
                    
        
        
        self.Img_palabra= wx.Image((self.direccion+"fotos/"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img_palabra= self.Img_palabra.Scale(100, 90, wx.IMAGE_QUALITY_HIGH)
        self.Img_palabra= wx.BitmapFromImage(self.Img_palabra)            
        
        self.Img_televisor= wx.Image((self.direccion+"imagenes/Ayudame.png"), wx.BITMAP_TYPE_ANY)
        self.Img_televisor= self.Img_televisor.Scale(90, 90, wx.IMAGE_QUALITY_HIGH)
        self.Img_televisor= wx.BitmapFromImage(self.Img_televisor)            
        
        self.bloque = wx.Image((self.direccion+"imagenes/blokeazul.jpg"), wx.BITMAP_TYPE_ANY)
        self.bloque= self.bloque.Scale(30, 30, wx.IMAGE_QUALITY_HIGH)
        self.bloque= wx.BitmapFromImage(self.bloque)            
        
        self.Img_yo = wx.Image((self.direccion+"imagenes/Animal1.png"), wx.BITMAP_TYPE_ANY)
        self.Img_yo= self.Img_yo.Scale(30, 30, wx.IMAGE_QUALITY_HIGH)
        self.Img_yo= wx.BitmapFromImage(self.Img_yo)            
      
        self.Img_premio = wx.Image((self.direccion+"imagenes/Ayudame.png"), wx.BITMAP_TYPE_ANY)
        self.Img_premio= self.Img_premio.Scale(30, 30, wx.IMAGE_QUALITY_HIGH)
        self.Img_premio= wx.BitmapFromImage(self.Img_premio)            
      
        self.Img_malo = wx.Image((self.direccion+"imagenes/Animal3.png"), wx.BITMAP_TYPE_ANY)
        self.Img_malo= self.Img_malo.Scale(30, 30, wx.IMAGE_QUALITY_HIGH)
        self.Img_malo= wx.BitmapFromImage(self.Img_malo)            
        self.completada=False    
        self.padre.tiempo.Stop()
        self.SetFocus()

        self.Refresh()
        # Activar el evento del reloj
        self.padre.tiempo.Start(1000)
        



