#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de elegir la palabra que esta escrita correctamente
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy


class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [9,6,u'Gontzal Uriarte',u'Elegir la palabra bien escrita'] )
        self.palabra=""
        self.tomado=-1
        self.archivo=""
        self.letra=""
        self.tabla=[["",0],["",0],["",0],["",0]] #palabra completa,pal. sin letra,letra,acertado
        self.fallos=0
        self.Img=""
        self.Img_x=range(350,350+150)
        self.Img_y=range(300,300+150)
        self.completada=False
        self.primera=True
        self.py=0;self.px=0;
    
    def inicializar(self):
        
        self.tabla=[["","","",0],["","","",0],["","","",0],["","","",0]] #palabra completa,pal. sin letra,letra,acertado

        self.Cuadro_x = []
        self.Cuadro_y = []
        self.Cuadro_x.append (range(20,420)) ; self.Cuadro_x.append (range(450,850)) ; self.Cuadro_x.append (range(20,420)) ; self.Cuadro_x.append (range(450,850))
        self.Cuadro_y.append (range(50,150)) ; self.Cuadro_y.append (range(50,150)) ; self.Cuadro_y.append (range(170,270)) ; self.Cuadro_y.append (range(170,270))
        
        
        self.letra=random.choice(self.P.dificultades)
        encontrado=False
        while not encontrado:
            self.palabra=random.choice(self.P.tabla)
            if self.letra in self.palabra and len(self.palabra)>8:
                encontrado=True
        self.archivo=self.palabra
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.palabra=self.palabra.replace('-','')

        listapalabra=self.palabra
        letra2= listapalabra[2]
        letra3= listapalabra[3]
        letra4= listapalabra[4]
        letra5= listapalabra[5]
        self.tabla[0][0]=self.palabra
        self.tabla[1][0]=listapalabra[:2:]+letra3+letra2+listapalabra[4::]
        self.tabla[2][0]=listapalabra[:3:]+letra4+letra3+listapalabra[5::]
        self.tabla[3][0]=listapalabra[:4:]+letra5+letra4+listapalabra[6::]
        random.shuffle(self.tabla)
        self.completada=False 
        

    def PaintJuego9(self,event):
        dc=wx.PaintDC(self)
        
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.SetBrush(wx.Brush('Red'));        dc.DrawRoundedRectangle(20,50,400,100,30); dc.DrawText(self.P.maymin(self.tabla[0][0]),140,75)
            dc.SetBrush(wx.Brush('Yellow'));       dc.DrawRoundedRectangle(450,50,400,100,30); dc.DrawText(self.P.maymin(self.tabla[1][0]),580,75)
            dc.SetBrush(wx.Brush('Green'));      dc.DrawRoundedRectangle(20,170,400,100,30); dc.DrawText(self.P.maymin(self.tabla[2][0]),140,200)
            dc.SetBrush(wx.Brush('Grey'));     dc.DrawRoundedRectangle(450,170,400,100,30); dc.DrawText(self.P.maymin(self.tabla[3][0]),580,200)
            dc.DrawRectangle(350,300,150,150)
            dc.DrawBitmap(self.Img,350,300)
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,100,450,300)
            dc.DrawBitmap(self.Img,350,120)
            dc.DrawText(self.P.maymin(self.palabra),350,300)
        event.Skip()
     
        
    def MJclic9(self,event):

        self.px,self.py= event.GetPosition()
        
                
        
        if not self.completada:
            for i in range (0,4):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    if self.tabla[i][0]==self.palabra:
                        self.completada=True
                        self.padre.sonido(22)
                        self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                        self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                        self.fallos=0
                        time.sleep(1)
                        self.sonido.habla(self.palabra)
                        self.P.puntosjuegos[9]+=1
                        self.P.puntosletras[self.padre.num_letra(self.letra)]+=1
                    else:
                        self.fallos+=1
                        self.padre.sonido(1)
                        self.P.fallosjuegos[9]+=1
                        self.P.fallosletras[self.padre.num_letra(self.letra)]+=1
        self.Refresh()
        event.Skip()        
    
    def MainJuego9(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()
        
    def Apoyo9(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)

            
            
        event.Skip()
        
    def Terminar9(self,event=None):
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        
        self.Unbind(wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_LEFT_DOWN)
    
        self.padre.pantalla=1 #pantalla de ejercicios
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        self.padre.Panel_ejercicios.Show()
        self.Hide()




        
        

    def Ayuda9(self,event):
        self.sonido.habla('Elige la palabra escrita correctamente')
        event.Skip()
        
    
        
    def Juego(self):
        self.SetBackgroundColour('Blue')
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego9)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda9)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar9)
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo9)
        self.Bind (wx.EVT_PAINT, self.PaintJuego9)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic9)
    
        self.padre.sonido(4)    
        self.Refresh()
        self.Show()
        
        



