#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de escribir correctamente una palabra.
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.S=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [10,2,u'Gontzal Uriarte',u'Escribir palabras'] )
        self.palabraconstruida=""
        self.palabra=""
        self.tomado=-1
        self.archivo=""
        self.tabla=[] # palabra, posicion de errores, escribir?
        self.padre.Pregunta=[0,1,2,3]
        self.img=""
        self.fallos=0
        self.completada=False
        self.oportunidad=0
        self.letra=""
        
    def inicializar(self):
        self.archivo=""
        self.tabla=[["",[],1],["",[],0],["",[],0],["",[],0]] # palabra, posicion de errores, escribir?      
        self.oportunidad=0
        self.fallos=0
        self.SetBackgroundColour('Blue')
        self.letra=random.choice(self.P.dificultades)
        encontrado=False
     
        while not encontrado:
            self.palabra=random.choice(self.P.tabla)
            if self.letra in self.palabra:
                encontrado=True
            
        self.archivo=self.palabra
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo+".png"), wx.BITMAP_TYPE_ANY)
        self.Img1= self.Img.Scale(250, 250, wx.IMAGE_QUALITY_HIGH)
        self.Img1= wx.BitmapFromImage(self.Img1)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.palabra=self.palabra.replace("-","")
        self.Pregunta[0].Hide();self.Pregunta[1].Hide();self.Pregunta[2].Hide();self.Pregunta[3].Hide()
        
        for elemento in self.Pregunta:
            elemento.SetValue('')
            elemento.Enable(True)
        self.Pregunta[0].SetFocus()    
        self.completada=False
        

    def PaintJuego10(self,event):
        dc=wx.PaintDC(self)
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.SetBrush(wx.Brush('Red'));        
            dc.DrawRoundedRectangle(10,10,360,400,20);
            dc.DrawText(u'E'+self.P.maymin('scribe esta palabra'),20,25)
            dc.DrawBitmap (self.Img1,50,120,False)
            if self.fallos<=3:
                for i in range(0,4):
                    if self.tabla[i][2]==1:
                        self.Pregunta[i].Show()
                        self.Pregunta[i].SetBackgroundColour('White')
                        
                    else:
                        self.Pregunta[i].Hide()
                self.Pregunta[self.oportunidad].SetFocus()
            else:
                dc.SetTextForeground((255,255,255))
                dc.DrawText(self.P.maymin(self.palabra),180-len(self.palabra)*10,75)
                self.P.fallosletras[self.padre.num_letra(self.letra)]+=4
                self.P.fallosjuegos[10]+=4
                self.completada=True
                
            
        elif self.completada and self.fallos<=3:
            for i in range(0,4):
                self.Pregunta[i].Hide()
            dc.SetBrush(wx.Brush('White'));
            dc.DrawRectangle(200,70,400,300)
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawBitmap(self.Img,325,130,False)
            dc.DrawText(self.P.maymin(self.palabra),400-10*len(self.palabra),310)
        event.Skip()
     
        
    def MotorJuego10(self,event):
        if self.oportunidad<=3:
            respuesta=self.Pregunta[self.oportunidad].GetValue()
            respuesta= respuesta.replace('\n','')
            palabra_usuario=list(respuesta)
            palabra_correcta=list(self.palabra)
            cont=0
            while cont<=len(palabra_usuario)-1 and cont<=len(palabra_correcta)-1:
                if palabra_usuario[cont].lower()!=palabra_correcta[cont].lower():
                    self.tabla[self.oportunidad][1].append(cont)
                cont+=1
            

            if len(self.tabla[self.oportunidad][1])!=0 :
                self.Pregunta[self.oportunidad].SetValue(''.join(palabra_usuario))
                self.Pregunta[self.oportunidad].SetStyle(len(palabra_correcta),0,wx.TextAttr("black","white"))
                for i in self.tabla[self.oportunidad][1]:
                    self.Pregunta[self.oportunidad].SetStyle(i+1,i,wx.TextAttr("Red","white"))
                if len(palabra_usuario)>len(palabra_correcta):
                    self.Pregunta[self.oportunidad].SetStyle(len(palabra_correcta),len(palabra_usuario),wx.TextAttr("Yellow","Black"))
                
                self.Pregunta[self.oportunidad].SetInsertionPoint(0)
                self.Pregunta[self.oportunidad].Enable(False)
                if self.oportunidad<3:
                    self.oportunidad+=1
                    self.tabla[self.oportunidad][2]=1
                self.fallos+=1
            
            elif ''.join(palabra_usuario).lower()==''.join(palabra_correcta).lower():
                self.padre.sonido(22)
                self.P.puntosletras[self.padre.num_letra(self.letra)]+=1
                self.P.puntosjuegos[10]+=1
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                for i in range(0,4): self.tabla[i][2]=0
                self.completada=True
            elif len(palabra_usuario)<len(palabra_correcta): #escrito correctamente pero incompleta, ????
                self.Pregunta[self.oportunidad].SetValue(''.join(palabra_usuario)+'?'*(len(palabra_correcta)-len(palabra_usuario)))
                self.Pregunta[self.oportunidad].SetInsertionPoint(0)
                self.Pregunta[self.oportunidad].Enable(False)
                if self.oportunidad<3 :
                    self.oportunidad+=1
                    self.tabla[self.oportunidad][2]=1
                self.fallos+=1
            elif len(palabra_usuario)>len(palabra_correcta):
                self.Pregunta[self.oportunidad].SetStyle(len(palabra_correcta),len(palabra_usuario),wx.TextAttr("Yellow","Black"))
                self.Pregunta[self.oportunidad].SetInsertionPoint(0)
                self.Pregunta[self.oportunidad].Enable(False)
                if self.oportunidad<3:
                    self.oportunidad+=1
                    self.tabla[self.oportunidad][2]=1
                self.fallos+=1

            self.Refresh()
        event.Skip()        
        
    def MainJuego10(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()                
        event.Skip()
        
    def Apoyo10(self,event):
        px,py= event.GetPosition()
        pxf=range(50,50+250)
        pyf=range(120,120+250)
        if (px in pxf)and (py in pyf):
            self.S.habla(self.palabra)
        self.Pregunta[self.oportunidad].SetFocus()
        event.Skip()
        
    def Terminar10(self,event):
        for i in range(0,4):
            self.Pregunta[i].Hide()
            self.Pregunta[i].Unbind(wx.EVT_TEXT_ENTER)
            self.Pregunta[i].Destroy
            
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Hide()
        self.padre.Panel_ejercicios.Show()
        self.padre.pantalla=1 #pantalla de ejercicios
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        event.Skip()

    def Ayuda10(self,event):
        self.S.habla(u'Intenta escribir la palabra de está imagen.')

        event.Skip()
        
        
        
    def Juego(self):
        
        self.Pregunta=[0,1,2,3]
        self.Pregunta[0]=wx.TextCtrl(id=wx.NewId(),name='P1',parent=self,pos=wx.Point(400,50),size=wx.Size(450,60), style=wx.TE_MULTILINE|wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        self.Pregunta[1]=wx.TextCtrl(id=wx.NewId(),name='P2',parent=self,pos=wx.Point(400,150),size=wx.Size(450,60), style=wx.TE_MULTILINE|wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        self.Pregunta[2]=wx.TextCtrl(id=wx.NewId(),name='P3',parent=self,pos=wx.Point(400,250),size=wx.Size(450,60), style=wx.TE_MULTILINE|wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        self.Pregunta[3]=wx.TextCtrl(id=wx.NewId(),name='P4',parent=self,pos=wx.Point(400,350),size=wx.Size(450,60), style=wx.TE_MULTILINE|wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        for i in range(0,4):
            self.Pregunta[i].SetFont(wx.Font(43,wx.DEFAULT,wx.NORMAL,wx.BOLD,0,"Edelfontmed"))
            
        self.Pregunta[0].Bind(wx.EVT_TEXT_ENTER,self.MotorJuego10)
        self.Pregunta[1].Bind(wx.EVT_TEXT_ENTER,self.MotorJuego10)
        self.Pregunta[2].Bind(wx.EVT_TEXT_ENTER,self.MotorJuego10)
        self.Pregunta[3].Bind(wx.EVT_TEXT_ENTER,self.MotorJuego10)
        
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda10)
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego10)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar10)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo10)
        self.Bind(wx.EVT_PAINT, self.PaintJuego10)
        self.inicializar()
        self.padre.sonido(4)
        self.Show()
        self.Refresh()
        



