#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de contar las sílabas de la palabra que corresponde a la imagen (JUEGO DE SÍLABAS)


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [14,1,u'Gontzal Uriarte',u'Contar sílabas'] )
        self.palabra=""
        self.archivo=""
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Img_x=""
        self.Img_y=""
        self.completada=False
        self.py=0;self.px=0;
        self.Cuadro_x=[1,2,3,4,5,6,7,8,9]
        self.Cuadro_y=[1,2,3,4,5,6,7,8,9]
        self.solucion=-1
        
    def inicializar(self):
        self.completada=False
        self.SetBackgroundColour('Blue')
        self.letra=random.choice(self.P.letras)
        encontrado=False
        while not encontrado:
            self.palabra=random.choice(self.P.tabla)
            if self.letra in self.palabra and len(self.palabra)>8:
                encontrado=True
        self.archivo=self.palabra
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.palabra=self.palabra.replace('-','')
        self.solucion=self.archivo.count('-')+1
        for i in range(0,6):
            self.Cuadro_x[i]=range(200+i*75,200+((i+1)*75))
            self.Cuadro_y[i]=range(350,350+75)
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        
    def PaintJuego14(self,event):
        dc=wx.PaintDC(self)
        
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.SetBrush(wx.Brush('Yellow'))
            
            for i in range(0,6):
                dc.DrawRectangle(200+ i*75 ,350 , 75, 75)
                dc.DrawText(str(i),233+i*75,380)
                
            dc.DrawRectangle(350,100,150,150)
            dc.DrawBitmap(self.Img,350,100)
            dc.DrawText('C'+self.P.maymin(u'uenta las sílabas de esta palabra'),200,50)
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,100,450,300)
            dc.DrawBitmap(self.Img,350,150)
            dc.DrawText(self.P.maymin(self.archivo),440-len(self.archivo)*10,320)
            dc.DrawText(self.P.maymin(str(self.solucion)+' silaba'+'s' if (self.solucion>1) else ''),340,110)
        event.Skip()
     
        
    def MJclic14(self,event):
        
        self.px,self.py= event.GetPosition()
        if not self.completada:
            eleccion=-1  
            for i in range(0,6):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    eleccion=i

            if eleccion == self.solucion:
                self.completada=True
                
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                self.padre.sonido(22)
                time.sleep(1)
                self.sonido.habla(self.palabra)
                self.P.puntosjuegos[14]+=1
            elif eleccion>=0:  # es mayor que -1, no ha sido correcta y ha elegido alguna respuesta 
                self.fallos+=1
                self.padre.sonido(1)    
                self.P.fallosjuegos[14]+=1
        self.Refresh()
        event.Skip()        
        
    def MainJuego14(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()

    def Apoyo14(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)
        event.Skip()
        
    def Terminar14(self,event):
        
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON) 
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        event.Skip()

    def Ayuda14(self,event):
        self.sonido.habla('Cuenta las silabas de la palabra '+self.palabra)
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego14)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda14)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar14)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo14)
        self.Bind(wx.EVT_PAINT, self.PaintJuego14)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic14)
        
        
        self.padre.sonido(4)
        self.Refresh()
        self.Show()
