#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de un juego como el buble duble con inversiones pq db y zs
#
#



import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [18,6,u'Gontzal Uriarte',u'Juego de globos para distinguir bdqp..'] )
        self.yo=""
        self.bloque=""
        self.Imagen=""
        self.nivel1= []
        self.pantalla=[]
        self.tomado=False
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.primera=True
        self.Bola=[1,2,3,4,5,6]
        self.ejecuta_bajarbolas=False
        self.ejecuta_subirbolas=False
        self.yo_x=1
        self.bolsa=[]
        self.tiempo=0
        self.Puntos=0
        self.Topetiempo=50
        self.contexpl=0
        self.bola_x=0
        self.bola_y=0
        self.bajando_bola=False
        self.Tiempobajando=0
        self.subiendo_bola=False
        self.Tiemposubiendo=0    
        self.bola=6
        
    def PaintJuego18(self,event):
        dc=wx.PaintDC(self)
        
        dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 

        if not self.completada:
            dc.SetPen(wx.Pen('White',6))
            dc.DrawLine(125+50*self.yo_x,10+50*8,125+50*self.yo_x,10+50*1)
            for i in range(0,9):
                for j in range(0,10):
                    if self.pantalla[i][j]==9:
                        dc.DrawBitmap(self.bloque,100+50*j,10+50*i,False)
                    if self.pantalla[i][j]>=0 and self.pantalla[i][j]<6:
                        dc.DrawBitmap(self.Bola[self.pantalla[i][j]],100+50*j,10+50*i,False)
                    if self.pantalla[i][j]==7:
                        dc.DrawBitmap(self.yo,100+50*j,10+50*i,False)
                    if self.pantalla[i][j]==6:
                        dc.DrawBitmap(self.yo,100+50*j,10+50*i,False)
                        self.contexplo=0
                        
                        
                        
            for i in range(0,len(self.bolsa)):
                dc.DrawBitmap(self.Bola[self.bolsa[i]],100+50*self.yo_x+6*i,50*9,False)
                
            dc.DrawText('Puntos: '+str(self.Puntos),660,60 )
            
            
            
        else:
            dc.SetFont(wx.Font(50, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(200,100,400,300,30)
            dc.DrawText('FIN',350,150)
            dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawText('Puntos: '+str(self.Puntos),230,300 )
        
        event.Skip()
     
    def MotorJuego18(self,event):
        tecla = event.GetKeyCode()
        
        if tecla==wx.WXK_LEFT and not self.completada:
            if self.pantalla[8][self.yo_x-1]!=9:
                self.pantalla[8][self.yo_x]=8
                self.yo_x-=1
                self.pantalla[8][self.yo_x]=7
                self.Refresh()
             
        if tecla==wx.WXK_RIGHT and not self.completada:
            if self.pantalla[8][self.yo_x+1]!=9:
                self.pantalla[8][self.yo_x]=8
                self.yo_x+=1
                self.pantalla[8][self.yo_x]=7
                self.Refresh()
            
        if tecla==wx.WXK_DOWN and not self.completada:
            self.ejecuta_bajarbolas=True
            self.Refresh()
            
        if tecla==wx.WXK_UP and not self.completada:
            self.ejecuta_subirbolas=True
            self.Refresh()
                     
        
        
        event.Skip()
        
    def MainJuego18(self,event):
        self.inicializar()
        self.completada=False
        self.padre.sonido(4)
        self.padre.tiempo.Stop()
        self.padre.tiempo.Start(40)
        self.Refresh()        
        event.Skip()

        
    def Terminar18(self,event):
        self.padre.tiempo.Stop()
        self.Unbind(wx.EVT_TIMER)
        self.padre.tiempo.Destroy()
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind(wx.EVT_CHAR)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_MOTION)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        
        
        event.Skip()

    def Ayuda18(self,event):
        self.sonido.habla(u'Junta las bolas iguales')
        self.SetFocus()
        
        
        event.Skip()
        
    def ontimer(self,event):   
        
        if not self.completada and not self.bajando_bola and not self.subiendo_bola:
            for i in range(1,8):
                if self.pantalla[8][i]<6:
                    self.completada=True
                    self.padre.sonido(1)
                    break
                

            self.tiempo+=1            
            if self.tiempo>self.Topetiempo:
                self.tiempo=0
                self.Topetiempo-=10
                self.pantalla.insert(1,[9,8,8,8,8,8,8,8,8,9])
                for i in range(1,9):
                    self.pantalla[1][i]=random.randint(0,5)
                self.pantalla[8][self.yo_x]=7
            self.Refresh()
         
                
                
        if self.ejecuta_bajarbolas and not self.bajando_bola and not self.subiendo_bola:
            for i in range(7,0,-1):
                if self.pantalla [i][self.yo_x] <6 and (self.bolsa == []  or self.pantalla [i][self.yo_x] in self.bolsa):
                    self.bola=self.pantalla [i][self.yo_x]
                    self.bola_x=self.yo_x
                    self.bola_y=i
                    self.Tiempobajando=0
                    self.bajando_bola=True
                    self.padre.sonido(5)
                    break
                elif self.pantalla [i][self.yo_x] <6 and (self.bolsa!=[] or  self.pantalla [i][self.yo_x] not in self.bolsa):
                    break
            self.ejecuta_bajarbolas=False
            self.Refresh()
        
        if self.bajando_bola:
            if self.bola_y<7 :
                if self.Tiempobajando==2:
                    self.pantalla [self.bola_y][self.bola_x]=8
                    self.bola_y+=1
                    self.pantalla [self.bola_y][self.bola_x]=self.bola
                else:
                    self.Tiempobajando+=1
            else:
                self.bolsa.append(self.bola)
                self.pantalla [self.bola_y][self.bola_x]=8
                self.bajando_bola=False
                self.Tiempobajando=0
            self.Refresh()
        
            
        
        
        
        if self.ejecuta_subirbolas and not self.bajando_bola and not self.subiendo_bola:
            subido=False
            if self.pantalla [7][self.yo_x] ==8 and (self.bolsa != []):
                self.pantalla[7][self.yo_x] = self.bolsa [-1]
                self.bolsa.pop(-1)
                subido=True
                self.Refresh()
                self.padre.sonido(5)
                self.subiendo_bola=True
                self.Tiemposubiendo=0
                self.bola_y=7
                self.bola_x=self.yo_x
                    
            self.ejecuta_subirbolas=False
            self.Refresh()
        
        
        if self.subiendo_bola:
            if self.pantalla [self.bola_y-1][self.bola_x]==8:
                if self.Tiemposubiendo==2:
                    self.pantalla [self.bola_y-1][self.bola_x]=self.pantalla [self.bola_y][self.bola_x]
                    self.pantalla [self.bola_y][self.bola_x]=8
                    self.bola_y-=1
                else:
                    self.Tiemposubiendo+=1
            else:
                self.subiendo_bola=False
                self.Tiemposubiendo=0
            self.Refresh()
        
        
        # explota bolas 
        if not self.subiendo_bola:
            for j in range(8,0,-1):
                ListaExplotar_xy=[]
                ListaExplotar=[]
                for i in range(8,0,-1):
                    if self.pantalla [i][j] <6 and (ListaExplotar == []  or self.pantalla [i][j] in ListaExplotar):
                        ListaExplotar.append(self.pantalla [i][j])
                        ListaExplotar_xy.append((i,j))
                    elif self.pantalla [i][j] <6 and (ListaExplotar!=[] or  self.pantalla [i][j] not in ListaExplotar):
                        break
                if len(ListaExplotar)>2:
                    for i in range(0,len(ListaExplotar)):
                        self.pantalla[ListaExplotar_xy[i][0]] [ListaExplotar_xy[i][1]] = 6
                        self.Puntos+=1
                        self.contexpl=0
                        
            explotado=False
            for j in range(8,0,-1):
                for i in range(8,0,-1):
                    if self.pantalla[i][j]==6 and self.contexpl>300:
                        self.pantalla[i][j]=8
                        explotado=True
                    else:
                        self.contexpl+=1
            if explotado:
                self.padre.sonido(22)
                self.P.puntosjuegos[18]+=1
            self.Refresh()
                         
        
        event.Skip()
        
        
    def inicializar(self):
        # Activar el evento del reloj
        self.padre.tiempo.Start(40)
        self.Refresh()
        self.tiempo=0
        self.Puntos=0
        self.completada=False
        self.pantalla=[]
        # 8= nada 9=bloque azul 0-6=las diferentes bolas
        
        self.pantalla=[[9,9,9,9,9,9,9,9,9,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,8,8,8,8,8,9],
                       [9,8,8,8,7,8,8,8,8,9]]
        self.yo_x=4
        for j in range(1,4):        
            for i in range(1,9):
                self.pantalla[j][i]=random.randint(0,5)

        self.Topetiempo=500
        self.SetFocus()
            
                

    def Juego(self):
        self.inicializar()
        self.SetBackgroundColour('blue')
        
        self.bloque = wx.Image((self.direccion+"imagenes//blokeazul.jpg"), wx.BITMAP_TYPE_ANY)
        self.bloque= self.bloque.Scale(50, 50, wx.IMAGE_QUALITY_HIGH)
        self.bloque= wx.BitmapFromImage(self.bloque)        
        
        self.yo= wx.Image((self.direccion+"imagenes//Animal1.png"), wx.BITMAP_TYPE_ANY)
        self.yo= self.yo.Scale(50, 50, wx.IMAGE_QUALITY_HIGH)
        self.yo= wx.BitmapFromImage(self.yo)        
        
        for i in range(0,6):
            self.Bola[i] = wx.Image((self.direccion+"imagenes//Bola"+str(i)+".png"), wx.BITMAP_TYPE_ANY)
            self.Bola[i]= self.Bola[i].Scale(50, 50, wx.IMAGE_QUALITY_HIGH)
            self.Bola[i]= wx.BitmapFromImage(self.Bola[i])
          
        self.SetFocus()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego18)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda18)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar18)
        self.Bind (wx.EVT_PAINT, self.PaintJuego18)
        self.Bind (wx.EVT_CHAR ,self.MotorJuego18)
        self.Bind (wx.EVT_MOTION,lambda s: self.SetFocus())
     
        self.padre.sonido(4)
        self.Show()
        
        self.Refresh()
        



