#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de discriminar ciertas letras
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [20,0,u'Gontzal Uriarte',u'Identificar con que letras están escritas'] )
        self.palabra=""
        self.primera= True
        self.archivo=""
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Img_x=0
        self.Img_y=0
        self.palabra=""
        self.archivo=""
        self.completada=False
        self.py=0;self.px=0;
        self.tabla=[1,2]
        self.solucion=-1
        self.bloque_x=[1,2]
        self.bloque_y=[1,2]        
        self.tiempo=0
        self.nivel=0
        self.t_ejercicios =[[u'b',u'p'],[u't',u'd'], 
                            [u'b',u'd'],[u'b', u'm'],
                            [u'z',u'ce'],[u'z',u'ci'],
                            [u'f',u'j'],[u'qu',u'ce'],
                            [u'qu',u'ci'],[u'g',u'c'],
                            [u's',u'z'],[u'll',u'ñ'], 
                            [u'n',u'm'],[u'b',u'd']]
        encontrado=False
        self.puntuacion=0
        
    def inicializar(self):
        self.completada=False
        self.tiempo=0
        self.nivel=0
        self.puntuacion=0
        self.SetBackgroundColour('Blue')
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        for i in range(0,2):
            self.bloque_x[i]= range(250+(170*i),350+(170*i))
            self.bloque_y[i]= range(300,400)
        ejercicio = random.randint(0,len(self.t_ejercicios)-1)
        for i in range(0,2):
            self.tabla[i]=self.t_ejercicios[ejercicio][i]
        solucion =random.randint(0,1)
        buscar=self.tabla[solucion]
        
        nobuscar=self.tabla[0 if (solucion==1) else 1]
        nobuscar=nobuscar.replace('e','')
        nobuscar=nobuscar.replace('i','')
        encontrado=False
        while not encontrado:
            self.palabra=random.choice(self.P.tabla)
            if (buscar in self.palabra) and (nobuscar not in self.palabra):
                encontrado = True
        self.archivo=self.palabra
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.palabra=self.palabra.replace('-','')
        self.Refresh()
        self.padre.tiempo.Start(40)
        
        
    def PaintJuego20(self,event):
        dc=wx.PaintDC(self)
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.SetBrush(wx.Brush('Yellow'))
            dc.DrawText(str(self.nivel)+' Puntos',300,50)
            if self.tiempo>100 and self.tiempo<140:
                dc.DrawText(self.palabra,480,160)
            for i in range(0,2):
                dc.DrawRectangle(self.bloque_x[i][0],self.bloque_y[i][0],self.bloque_x[i][-1]-self.bloque_x[i][0],self.bloque_y[i][-1]-self.bloque_y[i][0])
                muestra=self.tabla[i].replace('e','')
                muestra=muestra.replace('i','')
                dc.DrawText(self.P.maymin(muestra),self.bloque_x[i][0]+30 , self.bloque_y[i][0]+40 )
            dc.DrawBitmap(self.Img,300,100)
        else:
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.DrawRectangle(300,100,350,200)
            dc.DrawText("¡Muy bien! " + str(self.nivel)+ " puntos",310,150)     
        
        event.Skip()
     
    def ontimer(self,event):
        if not self.completada:
            self.tiempo+=1
            if self.nivel>5:
                    self.completada = True
            if self.tiempo==20:
                self.sonido.habla(self.palabra)

    
        self.Refresh()
        event.Skip()
    
    def MJclic20(self,event):
        self.px,self.py= event.GetPosition()
        eleccion=-1
        if not self.completada:
            buscar=""
            botonpulsado=False
            for i in range(0,2):
                if self.px in self.bloque_x[i] and self.py in self.bloque_y[i]:
                    buscar = self.tabla[i]
                    botonpulsado=True
                    break
            if botonpulsado:
                if buscar in self.palabra:
                    self.padre.sonido(22)
                    self.P.puntos = self.P.puntos+(self.P.incremento/(self.fallos+1))
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                    self.P.puntosjuegos[20]+=1
                    if buscar in self.P.dificultades: self.P.puntosletras[self.padre.num_letra(buscar)]+=1
                    solucion = random.randint(0,1)
                    buscar= self.tabla[solucion]
                    nobuscar=self.tabla[0 if (solucion==1) else 1]
                    nobuscar=nobuscar.replace('e','')
                    nobuscar=nobuscar.replace('i','')
                    encontrado=False
                    while not encontrado:
                        self.palabra=random.choice(self.P.tabla)
                        if buscar in self.palabra and nobuscar not in self.palabra:
                            encontrado = True
                    self.archivo=self.palabra
                    self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
                    self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
                    self.Img= wx.BitmapFromImage(self.Img)
                    self.palabra=self.palabra.replace('-','')
                    self.tiempo=0
                    self.nivel+=1
                    
                else:
                    if self.nivel>=1:
                        self.nivel-=2
                    else:
                        self.nivel=0        
                    self.padre.sonido(1)
                    self.P.fallosjuegos[20]+=1
                    if buscar in self.P.dificultades: self.P.fallosletras[self.padre.num_letra(buscar)]+=1
                    
        self.Refresh()
        event.Skip()        
        
    def MainJuego20(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()

    def Apoyo20(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)
        event.Skip()
        
    def Terminar20(self,event):
        self.padre.tiempo.Stop()
        self.Unbind(wx.EVT_TIMER)
        self.padre.tiempo.Destroy()
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_KEY_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_MOTION)
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        event.Skip()

    def Ayuda20(self,event):
        self.sonido.habla('Cuenta la vocal :'+self.letra+'.De la palabra '+self.palabra)
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego20)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda20)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar20)  
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo20)
        self.Bind(wx.EVT_PAINT, self.PaintJuego20)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic20)
        self.SetFocus()

        self.padre.sonido(4)
        self.Refresh()
        self.Show()
        
        
        

