#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de contar las palabras de una frase.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [23,3,u'Gontzal Uriarte',u'Contar las palabras de una frase'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.Palabras=[]
        self.Tablong=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.cogido=False
        self.FraseConstruida=""
        self.ListaFrascons=[]        
        self.dicho=False
        self.nivel=0
        self.activo=[]
        self.Img=""
        self.longitudfrase=0
        self.correcta=False
        
    def inicializar(self):
        self.SetBackgroundColour('Blue')
        self.correcta=False
        self.fallos=0
        self.completada=False
        self.dicho=False
        self.FraseConstruida=""
        self.ListaFrascons=[]
        Terminado=False
        cont=0
        while not Terminado:
            cont+=1
            self.Frase=random.choice(self.P.Frases)
            if (len(self.Frase)<30 + self.nivel and len(self.Frase)>20 + self.nivel) or (cont>1000):
                Terminado=True
                
        self.Frase=self.Frase [:-1:]
        self.Palabras=self.Frase.split(" ")
        self.longitudfrase=len(self.Palabras)
        for i in range(0,len(self.Palabras)):
            self.activo.append(True)
        self.Img_x=range(600,600+100)
        self.Img_y=range(70,70+100)
        self.corregir.Show()
        self.Numero.Show()
        self.SetFocus()
        
    def PaintJuego0(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(23, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
                
        if not self.completada:
            dc.DrawText('P'+self.P.maymin(u'ulsa aquí para escuchar la frase'),70,100)
            dc.DrawBitmap(self.Img,self.Img_x[0],self.Img_y[0])
            dc.DrawText(u'¿C'+self.P.maymin(u'uántas palabras tiene?: '),70,250)    
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawText('N'+self.P.maymin(u'úmero de palabras: ')+str(self.longitudfrase),50,50)    
            dc.DrawRoundedRectangle(50,100,750,200,20)
            frases=["","",""]
            cont=0
            for i in range(0,len(self.Palabras)):
                frases[cont]+=self.Palabras[i]+' '
                long,anch=dc.GetTextExtent(frases[cont])
                if long>500:
                    cont+=1
            for i in range(0,3):
                dc.DrawText(frases[i],70,120+(i*50))
            
            
        event.Skip()
     
        
    def MJclic0(self,event):
        self.px,self.py= event.GetPosition()    
        if self.px in self.Img_x and self.py in self.Img_y:
            self.sonido.habla(self.Frase)
        event.Skip()        
        
    def MainJuego0(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.padre.Refresh()      
        
        event.Skip()
                
    def Apoyo0(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar0(self,event):
        
        self.corregir.Destroy()
        self.Numero.Destroy()
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_PAINT)
     
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        event.Skip()

    def Ayuda0(self,event):
        self.sonido.habla(u'Cuenta las palabras de esta frase.'+self.Frase)
        self.SetFocus()
        event.Skip()
        
    def Corregir0 (self,event):
        if not self.completada:
            if str(self.longitudfrase) == self.Numero.GetValue():
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.P.puntosjuegos[23]+=1
                self.fallos=0
                self.nivel+=5
                self.completada=True
                self.Refresh()
                self.padre.sonido(22)
                self.corregir.Hide()
                self.Numero.Hide()
            else:
                self.padre.sonido(30)
                self.fallos+=1
                self.P.fallosjuegos[23]+=1
                if self.fallos==3: 
                    self.completada=True
                    self.corregir.Hide()
                    self.Numero.Hide()
                    self.Refresh()
        event.Skip()
        
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(350,350),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir0)
        self.Numero=wx.TextCtrl(id=wx.NewId(),name='Numero',parent=self,pos=wx.Point(480,230),size=wx.Size(100,60), style=wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='0')
        self.Numero.SetFont(wx.Font(43,wx.DEFAULT,wx.NORMAL,wx.BOLD,0,"Edelfontmed"))
        self.Img=wx.Image(self.direccion+'imagenes//120px-Play_icon.png',wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego0)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda0)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar0)  
        
     
        self.Bind(wx.EVT_PAINT, self.PaintJuego0)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic0)
        
        self.corregir.SetFocus()
        self.padre.sonido(4)
        self.Refresh()
        self.Show()
