#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de acertar los sinonimos 
#



import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [31,2,u'Gontzal Uriarte',u'Sinónimos'] )
        self.palabra=['','','']
        self.archivo=""
        self.numero=1
        self.fallos=0
        self.completada=False
        encontrado=False
        self.memoriza=True
        self.tabla=[]
        
        
        for i in range(0,10):
                contenido=random.choice(self.P.Sinonimos).split('-')
                contenido.append('Escondido')
                self.tabla.append(contenido)
        self.boton_x=[0,1,2,3,4,5,6,7,8,9]
        self.boton_y=[0,1,2,3,4,5,6,7,8,9]
        
        
        
    def inicializar(self):
        
        # Activar el evento del reloj
        self.padre.tiempo.Start(5000)
        
        self.completada=False
        self.palabra=['','','']
        if self.numero<9 : 
            self.numero+=1
        else:
            self.numero=2
            self.tabla=[]
            for i in range(0,10):
                contenido=random.choice(self.P.Sinonimos).split('-')
                contenido.append('Escondido')
                self.tabla.append(contenido)        
                
        for i in range(0,self.numero):
            self.tabla[i][2]='Visible'
            self.boton_x[i]=range(300,600)
            self.boton_y[i]=range(10+i*50,60+i*50)
            
        

        
    def PaintJuego21(self,event):
        dc=wx.PaintDC(self)
        self.SetBackgroundColour('Blue')
        
        if not self.completada:
            for i in range(0,self.numero):
                if self.tabla[i][2]=='Visible':
                    dc.SetPen(wx.Pen('Blue',2))
                    dc.SetBrush(wx.Brush('Yellow'))
                    dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))  
                    ancho,alto=dc.GetTextExtent(self.P.maymin(self.tabla[i][0]))
                    dc.DrawRectangle(self.boton_x[i][0],self.boton_y[i][0],300,50)
                    dc.DrawText(self.P.maymin(self.tabla[i][0]),(300-ancho)/2+self.boton_x[i][0],10+self.boton_y[i][0])
            dc.SetPen(wx.Pen('White',6))
            dc.SetBrush(wx.Brush('Red'))
            dc.DrawRoundedRectangle(20,200,270,60,20)
            dc.DrawText(self.P.maymin(self.palabra[1]),30,210)
        else:
            dc.SetPen(wx.Pen('Black',6))
            dc.SetBrush(wx.Brush('White'))
            dc.DrawRoundedRectangle(100,50,700,400,10)
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))  
            dc.DrawText(self.P.maymin(u'Felicidades has aprendido estos sinónimos:'),110,60)
            dc.SetFont(wx.Font(18, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Edelfontmed"))  
            for i in range(0,self.numero):
                dc.DrawText(self.P.maymin(str(i+1)+'-. '+self.tabla[i][0]+' - '+self.tabla[i][1]),350,120+i*35)
            
        event.Skip()
    
        
    def ontimer(self,event):    
        if not self.completada: 
            for i in range(1,100):
                self.palabra=self.tabla[random.randint(0,self.numero-1)]
                if self.palabra[2]=='Visible':
                    self.sonido.habla(self.palabra[1])
                    break
                else:
                    self.palabra=["","",'']
        
        self.Refresh()
    
        event.Skip()
    
    def MotorJuego21(self,event):
        
        tecla = event.GetKeyCode()
        self.Refresh()
        event.Skip()        
        
    def MainJuego21(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()

    def Mclic31(self,event):
        self.px,self.py= event.GetPosition()
        for i in range(0,self.numero):
            if self.px in self.boton_x[i] and self.py in self.boton_y[i] and self.tabla[i][2]=='Visible':
                if self.tabla[i][0]==self.palabra[0]:
                    self.tabla[i][2]='Escondido'
                else:
                    self.padre.sonido(1)
                    self.P.fallosjuegos[31]+=1
                    
                    
                    
        encontrado=False
        for i in range(0,self.numero):
            if self.tabla[i][2]=='Visible': encontrado=True
        if not encontrado:
            self.padre.sonido(22)
            self.completada=True
            self.P.puntosjuegos[31]+=1
            if self.numero>8:
                self.P.puntos=self.P.puntos+(self.P.incremento)
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)

        self.Refresh()
        event.Skip()
    
    
    
    def Terminar21(self,event):
        
        self.padre.tiempo.Stop()
        self.padre.tiempo.Destroy()
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
     
        
        event.Skip()

    def Ayuda21(self,event):
        self.sonido.habla(u'Escucha y haz clic en el sinónimo que le corresponda')
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego21)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda21)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar21)  
        
        self.Bind (wx.EVT_LEFT_DOWN,self.Mclic31)
        self.Bind (wx.EVT_PAINT, self.PaintJuego21)
        self.Bind (wx.EVT_KEY_DOWN,self.MotorJuego21)
        
        
        self.padre.sonido(4)
        self.Show()
        self.Refresh()
        

