#!/usr/bin/env python
# -*- coding: utf-8 -*-

import wx
import os

class Ejercicios(wx.Panel):
    def __init__(self, parent,P,direccion,direccionAlumnos,N_Ejercicios):
        wx.Panel.__init__(self, parent, wx.ID_ANY)
        
        self.padre=parent  # El padre es katamotzprincipal
        self.P=P
        self.direccionAlumnos=direccionAlumnos
        self.direccion=direccion
        self.N_Ejercicios=N_Ejercicios
        # configura la pantalla
        self.SetBackgroundColour('Blue')
        self.padre.SetBackgroundColour('Blue')
        Ventana_Sx,Ventana_Sy=self.padre.GetSize()
        Panel_Px=0; Panel_Py=0;
        if  Ventana_Sx>(850+120): Panel_Px= (Ventana_Sx-(850+120))/2 # Este panel 850 el de control 100
        if  Ventana_Sy>500: Panel_Py= (Ventana_Sy-500)/2
        self.SetPosition((Panel_Px,Panel_Py))
        self.SetSize((850,500))
     
        self.Img_Ejercicio=[]
        self.Ejercicio=[]
        # la tabla de ejercicios se rellenará con un archivo.
        for i in range(0,N_Ejercicios):
            self.Img_Ejercicio.append(i)
            self.Ejercicio.append(i)

        # carga las imagenes
        for i in range(0,self.N_Ejercicios):
            try:
                self.Img_Ejercicio[i]=wx.Image(direccion+'imagenes//Ejercicios//Ejercicio'+str(i)+'.png',wx.BITMAP_TYPE_ANY).ConvertToBitmap()
            except:
                print "Error falta imagen de ejercicio:",i,
                print "Este archivo de imagen se encuentra en usr/bin/katamotz-ejercicios/imagenes"
        
        #EJERCICIOS 
        for i in range(0,self.N_Ejercicios): # cargando dentro del array ejercicios los botones-imagenes 
            self.Ejercicio[i]= wx.BitmapButton(self,i,self.Img_Ejercicio[i],(1,1),(110,120),wx.BITMAP_TYPE_ANY)
            self.Ejercicio[i].Bind(wx.EVT_BUTTON,self.EjecutaJuego)
            self.Ejercicio[i].Bind(wx.EVT_MOTION,self.ExplicaJuego)
            self.Ejercicio[i].Hide()        
            
    def CargaEjercicios(self,Tipoejercicio):
        conty=0
        contx=0
        for i in range(0,self.N_Ejercicios):
            if self.padre.Tabla_Ejercicios[i][1]== Tipoejercicio:
                if contx>5: 
                    conty+=1
                    contx=0
                self.Ejercicio[i].SetPosition ((50+(130*contx),50+(130*conty)))
                self.Ejercicio[i].Show()
                contx+=1
    def ExplicaJuego(self,event):
        btn = event.GetEventObject()
        self.padre.SetTitle('  Katamotz Ejercicios:       '+self.padre.Tabla_Ejercicios[btn.GetId()][3]+'   '+str(self.padre.Tabla_Ejercicios[btn.GetId()][0]))

        
    def EjecutaJuego(self,event): 
        btn = event.GetEventObject()
        # crea un timer en la ventana principal
        self.padre.tiempo = wx.Timer(self.padre, -1)
        self.padre.tiempo.Stop()
        
        
        try: # Si la actividad tiene un timer intenta crear un vinculo entre el evento timer(tiempo) y su procedimiento (.ontimer)
            self.padre.Bind (wx.EVT_TIMER, self.padre.muestra[btn.GetId()].ontimer,self.padre.tiempo)
        except:
            pass
        
        
        # Elimina los antiguos Binds del panel de control puesto que el nuevo juego aplicará los suyos
        self.padre.Panel_control.Repetir.Unbind (wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind (wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind (wx.EVT_BUTTON)
    
        self.Hide()  # Esconde pantalla de Ejercicios.
        self.padre.pantalla=2 # 2:pantalla del ejercicio
        self.padre.muestra[btn.GetId()].Juego()  # Carga el Juego cuyo padre es katamotzprincipal
        event.Skip()        
