#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
#
#

import wx
import codecs
import sys
import os
import random
import time




class ModuloEstadistica(wx.Panel):
    def __init__(self,Padre,Palabras,N_Ejercicios,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(1000,520),style=wx.WANTS_CHARS)

        self.P=Palabras
        self.padre=Padre
        self.N_Ejercicios=N_Ejercicios
        self.direccion=direccion
        self.x=-1
        self.TipoEjer=[u'Letras',u'Sílabas',u'Palabras',u'Frases',u'Textos',u'Ortografía',u'Inversiones']
        self.puntos=0
     
        
        
    def inicializar(self):
        self.SetBackgroundColour('Blue')
        
        
    def PaintJuego0(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Edelfontmed")) 
        dc.SetPen(wx.Pen('Black',5))
        dc.SetBrush(wx.Brush('Yellow'))
        dc.DrawRectangle(50,20,750,170)
        indicemax=1
        for i in self.P.puntosletras: 
            if i > indicemax: indicemax=i
        for i in self.P.fallosletras: 
            if i > indicemax: indicemax=i
        for i in range(0,len(self.P.dificultades)):
            dc.SetPen(wx.Pen('Blue',10))
            if self.P.puntosletras[i]*50/indicemax != 0:
                dc.DrawLine(80+30*i,80,80+30*i,80-self.P.puntosletras[i]*50/indicemax)
            dc.SetPen(wx.Pen('Red',10))
            if self.P.fallosletras[i]*50/indicemax != 0:
                dc.DrawLine(80+30*i,120,80+30*i,120+self.P.fallosletras[i]*50/indicemax)
            if self.P.fallosletras[i]>self.P.puntosletras[i]:
                dc.SetTextForeground('red')
            else:
                dc.SetTextForeground('Blue')
            num=0
            if (len(self.P.dificultades[i])==2): num=5
            dc.DrawText(self.P.maymin(self.P.dificultades[i]),(75+30*i)- num ,90)
        
        
        dc.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.SetPen(wx.Pen('Black',5))
        dc.SetBrush(wx.Brush('Yellow'))
        dc.DrawRectangle(50,200,750,260)
        indicemax=1
        for i in self.P.puntosjuegos: 
            if i > indicemax: indicemax=i
        for i in self.P.fallosjuegos: 
            if i > indicemax: indicemax=i
        for i in range(0,self.N_Ejercicios):
            dc.SetPen(wx.Pen('Blue',10))
            if self.P.puntosjuegos[i]*50/indicemax!=0:
                dc.DrawLine(80+20*i,280,80+20*i,280-self.P.puntosjuegos[i]*50/indicemax)
            dc.SetPen(wx.Pen('Red',10))
            if self.P.fallosjuegos[i]*50/indicemax!=0:
                dc.DrawLine(80+20*i,320,80+20*i,320+self.P.fallosjuegos[i]*50/indicemax)
            if self.P.fallosjuegos[i]>self.P.puntosjuegos[i]:
                dc.SetTextForeground('red')
            else:
                dc.SetTextForeground('Blue')
            dc.DrawText(self.P.maymin(str(i)),75+20*i,295)
        dc.SetFont(wx.Font(14, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.SetTextForeground('Black')
        for i in range(0,self.N_Ejercicios):
            if self.padre.Tabla_Ejercicios[i][0]==self.x:
                dc.DrawText(self.P.maymin(unicode(self.padre.Tabla_Ejercicios[i][3])) ,65, 400)
                dc.DrawText(self.P.maymin(str('Puntos:'+str(int(self.P.puntosjuegos[i]))+' Fallos:'+str(int(self.P.fallosjuegos[i])))) ,600, 400)
                dc.DrawText(self.P.maymin(self.TipoEjer[self.padre.Tabla_Ejercicios[i][1]]) ,65, 430)
                break
        dc.SetTextForeground('Brown')
        dc.DrawText(self.P.maymin(u'Nombre del alumno: '+self.P.nombrealumno+u'              Puntuación general:'+str(int(self.puntos))) ,65, 370)
        event.Skip()
     
        
    def MJclic0(self,event):
        self.px,self.py= event.GetPosition()    
        self.Refresh()
        event.Skip()        
        
    def MainJuego0(self,event):
        self.inicializar()
        self.Refresh()        
        event.Skip()
        
    def Mousemotion(self,event):
        self.px,self.py= event.GetPosition()
        if self.px>80 and self.px<780:
            if self.py>200 and self.py<400:
                self.x=(self.px-70)/20
        else:
            self.x=-1
            
        event.Skip()
        
    def MJtecla0(self,event):
        tecla=event.GetKeyCode()
        self.Refresh()
        event.Skip()
        
    def Apoyo0(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar0(self,event=None):
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind (wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        self.Unbind (wx.EVT_MOTION)
        self.Unbind (wx.EVT_BUTTON)
        self.padre.pantalla=0 #pantalla de ejercicios
        self.Hide()
        self.padre.Panel_tipo.Show()
        self.padre.Herramientas2.Enable(True)
        self.padre.Reloj.Stop()
        self.padre.Reloj.Unbind(wx.EVT_TIMER)
        self.padre.Reloj.Destroy()
        self.padre.frame_1_menubar.EnableTop(1, True)

        
    def Ayuda0(self,event):
        self.sonido.habla(u'Estas son las estadisticas de '+self.P.nombrealumno)
        event.Skip()
    def ontimer(self,event):

        self.Refresh()
        event.Skip()
        
    def Comienza(self):       
        self.padre.Herramientas2.Enable(False) 
        self.Img_Terminar=wx.Image(self.direccion+'imagenes'+"//"+'Terminar.png',wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        self.Terminar=wx.BitmapButton(self,-1,self.Img_Terminar,(810, 30),(100,100),wx.BITMAP_TYPE_ANY)        
        self.inicializar()
        self.Show()
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo0)
        self.Bind (wx.EVT_PAINT, self.PaintJuego0)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic0)
        self.Bind (wx.EVT_MOTION,self.Mousemotion)
        self.Terminar.Bind (wx.EVT_BUTTON, self.Terminar0)
        self.padre.Reloj = wx.Timer(self.padre, -1)
        self.padre.Bind(wx.EVT_TIMER,self.ontimer,self.padre.Reloj)
        self.padre.Reloj.Start(100)
        for i in self.P.puntosjuegos: self.puntos+=i
        self.SetFocus()
        self.Refresh()
        







