#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de Juntar palabras para formar frases.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(850,520),style=wx.WANTS_CHARS)

        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [0,3,u'Gontzal Uriarte',u'Ordenar frases'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.Palabras=[]
        self.Tablong=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.cogido=False
        self.FraseConstruida=""
        self.ListaFrascons=[]        
        self.dicho=False
        self.nivel=0
        self.activo=[]
        
    def inicializar(self):
        self.completada=False
        self.dicho=False
        self.FraseConstruida=""
        self.ListaFrascons=[]
        self.SetBackgroundColour('Blue')
        Ventana_Sx,Ventana_Sy=self.padre.GetSize()
        Panel_Px=0; Panel_Py=0;
        if  Ventana_Sx>(850+120): Panel_Px= (Ventana_Sx-(850+120))/2 # Este panel 850 el de control 100
        if  Ventana_Sy>500: Panel_Py= (Ventana_Sy-500)/2
        self.SetPosition((Panel_Px,Panel_Py))
        self.SetSize((850,500))
        self.padre.Panel_control.SetPosition((Panel_Px + 870,Panel_Py))
        Terminado=False
        cont=0
        while not Terminado:
            cont+=1
            self.Frase=random.choice(self.P.Frases)
            if (len(self.Frase)<30 + self.nivel and len(self.Frase)>20 + self.nivel) or (cont>1000):
                Terminado=True
                
        self.Frase=self.Frase [:-1:]
        self.Palabras=self.Frase.split(" ")
        random.shuffle(self.Palabras)
        self.activo = []
        for i in range(0,len(self.Palabras)):
            self.activo.append(True)
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        self.corregir.Show()
        
    def PaintJuego0(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        self.Tablalong=[]
        for i in range(0,len(self.Palabras)):
            self.Tablalong.append(dc.GetTextExtent(self.P.maymin((self.Palabras[i]))))
            
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetBrush(wx.Brush('Yellow'))
            dc.DrawRectangle(50,270,750,150)
            # imprime las frases
            cuadrofrases=["","","",""]
            cont=0
            for i in range(0,len(self.ListaFrascons)):
                cuadrofrases[cont]+=self.ListaFrascons[i]
                largo,ancho=dc.GetTextExtent(self.P.maymin(cuadrofrases[cont]))
                if largo>500:
                    cont+=1
            for i in range(0,4):
                dc.DrawText(self.P.maymin(cuadrofrases[i]),60,300+(40*i))
                
            # imprime las palabras si están activas
            contx=0
            conty=0
            self.bloque_x=[]
            self.bloque_y=[]
            for i in range(0,len(self.Palabras)):
                if conty>3:
                    conty=0
                    contx+=1
                self.bloque_x.append(range(50+(250*contx)-10, 50+(250*contx)+self.Tablalong[i][0]+10))
                self.bloque_y.append(range(50+(50*conty),50+(50*conty)+30))
                if self.activo[i]:
                    dc.DrawRoundedRectangle(self.bloque_x[i][0],self.bloque_y[i][0],self.bloque_x[i][-1]-self.bloque_x[i][0],self.bloque_y[i][-1]-self.bloque_y[i][0],10)
                    dc.DrawText(self.P.maymin(self.Palabras[i]),50+(250*contx),50+(50*conty))
                conty+=1
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(50,100,750,200,20)
            frases=["","",""]
            cont=0
            for i in range(0,len(self.ListaFrascons)):
                frases[cont]+=self.ListaFrascons[i]
                long,anch=dc.GetTextExtent(self.P.maymin(frases[cont]))
                if long>500:
                    cont+=1
            for i in range(0,3):
                dc.DrawText(self.P.maymin(frases[i]),70,120+(i*50))
            
        event.Skip()
     
        
    def MJclic0(self,event):
        self.px,self.py= event.GetPosition()    
        for i in range(0,len(self.Palabras)):
            if self.px in self.bloque_x[i] and self.py in self.bloque_y[i] and self.activo[i]:
                self.FraseConstruida+=self.Palabras[i]+" "
                self.ListaFrascons.append(self.Palabras[i]+" ")
                self.activo[i]= False
                self.sonido.habla(self.Palabras[i])
        self.Refresh()
        event.Skip()        
        
    def MainJuego0(self,event):
        self.inicializar()
        self.Refresh()        
        event.Skip()
        
    def MJtecla0(self,event):
        tecla=event.GetKeyCode()
        fr=""
 
        if tecla==wx.WXK_BACK and not self.completada and len(self.FraseConstruida)>0:
            for i in range(0,self.FraseConstruida.count(" ")-1):
                fr+=self.ListaFrascons[i]
            self.FraseConstruida=fr
            for i in range(0,len(self.Palabras)):
                if self.Palabras[i] == self.ListaFrascons[-1][0:-1:] and not self.activo[i]:
                    self.activo[i] = True
            self.ListaFrascons.pop()
        
        self.Refresh()
        event.Skip()
        
    def Apoyo0(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar0(self,event=None):
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind (wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        self.Unbind (wx.EVT_MOTION)
        self.corregir.Unbind (wx.EVT_CHAR)
        
        self.padre.pantalla=1 #pantalla de ejercicios
        self.Hide()
        self.padre.Panel_ejercicios.Show()
        
    def Ayuda0(self,event):
        
        self.sonido.habla(u'Forma una frase...pinchando en las palabras:'+self.Frase)
        event.Skip()
        
    def Corregir0 (self,event):
        if not self.completada:
            if self.Frase == self.FraseConstruida[:-1:]:
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                self.nivel+=1
                self.completada=True
                self.Refresh()
                self.corregir.Hide()
                self.padre.sonido(22)
                self.P.puntosjuegos[0]+=1
            else:
                self.padre.sonido(30)
                self.P.fallosjuegos[0]+=1
        event.Skip()
        
    def Juego(self):       
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(340,400),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir0)
        self.inicializar()
        self.Show()
        
        
        self.padre.Panel_control.Repetir.Bind (wx.EVT_BUTTON, self.MainJuego0)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON, self.Terminar0)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON, self.Ayuda0)
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo0)
        self.Bind (wx.EVT_PAINT, self.PaintJuego0)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic0)
        # Cuando hay controles wx y se necesita recoger eventos desde el control.
        self.Bind (wx.EVT_MOTION,lambda s: self.SetFocus())
        self.corregir.Bind (wx.EVT_CHAR,self.MJtecla0)

        self.corregir.SetFocus()
        self.Refresh()
