#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de un cuadro de silabas 
#
#



import wx
import codecs
import sys
import os
import random




class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [1,1,u'Gontzal Uriarte',u'Cuadro de silabas'] )    
        self.tabla=[[[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']]]
        self.acertadas=0
        self.completada=False
        self.consonante=""
    
    def inicializatabla(self):
        self.SetBackgroundColour('Blue')
        Ventana_Sx,Ventana_Sy=self.padre.GetSize()
        Panel_Px=0; Panel_Py=0;
        if  Ventana_Sx>(850+120): Panel_Px= (Ventana_Sx-(850+120))/2 # Este panel 850 el de control 100
        if  Ventana_Sy>500: Panel_Py= (Ventana_Sy-500)/2
        self.SetPosition((Panel_Px,Panel_Py))
        self.SetSize((850,500))
        self.padre.Panel_control.SetPosition((Panel_Px + 870,Panel_Py))
        
        self.tabla=[[[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']], [[1, ''], [1, ''], [1, ''], [1, '']]]
        self.acertadas=0
        self.completada=False
        vocal=unicode(random.choice('aeiou'))
        self.consonante=unicode(random.choice(self.P.dificultades))
        self.t=[]
        posiblessilabas=[]    
        for elemento in self.P.silabasTODAS:
            if (vocal in elemento) : 
                posiblessilabas.append(elemento)    
        for i in range(0,4):
            a=random.choice(posiblessilabas)
            random.shuffle(posiblessilabas)
            for i in range (0,len(posiblessilabas)) :
                b=random.choice(posiblessilabas)
                if self.consonante in b: break
            self.t.append(a)
            self.t.append(b)
            self.t.append('.'+a)
            self.t.append('.'+b)
            
        random.shuffle(self.t)
        # introduce en la tabla los datos
        for i in range(0,4):
            self.tabla[i][0][1]=self.t[i*4+0]
            self.tabla[i][1][1]=self.t[i*4+1]
            self.tabla[i][2][1]=self.t[i*4+2]
            self.tabla[i][3][1]=self.t[i*4+3]
        self.seleccion1=(-1,-1)
        random.shuffle(self.tabla)
    
    def MainJuego1(self,event):
        self.Juego()
        event.Skip()
        
  
    def PaintJuego1(self,event):
        # En la tabla algunas silabas van precedidas de un ".". De este modo distinguiremos las sonoras y las visuales.
        dc=wx.PaintDC(self)
        
        if not self.completada:
            dc.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))
            for y in range (0,4):
                for x in range(0,4):
                    if self.tabla[x][y][0]==1:
                        if self.tabla[x][y][1][0] ==".":
                            dc.DrawBitmap(wx.Image(self.direccion+"imagenes//blokeazulplay.jpg").ConvertToBitmap(),20+x*150,50+y*75,False)
                        else:
                            dc.DrawBitmap(wx.Image(self.direccion+"imagenes//blokeamarillo.jpg").ConvertToBitmap(),20+x*150,50+y*75,False)
                            dc.DrawText(self.P.maymin(self.tabla[x][y][1]),20+20+x*150,50+15+y*75)
                    elif self.tabla[x][y][0]==2 and self.tabla[x][y][1][0]== ".":
                            dc.DrawBitmap(wx.Image(self.direccion+"imagenes//blokeazulplaysel.jpg").ConvertToBitmap(),20+x*150,50+y*75,False)    
                    elif self.tabla[x][y][0]==0:
                        dc.SetBrush(wx.WHITE_BRUSH)
                        dc.SetPen(wx.Pen('WHITE', 0))                    
                        dc.DrawRectangle(20+x*150,50+y*75,150,75)
        else:
            dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))
            dc.SetTextForeground("White")
            dc.DrawText(u'¡Muy Bien, lo has conseguido!',100,200)
                    
        event.Skip()
    
    def Terminar1(self,event):
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.Hide()
        self.padre.Panel_ejercicios.Show()
        self.padre.pantalla=1 #pantalla de ejercicios
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        event.Skip()

    def MotorJuego1(self,event):    
        px,py= event.GetPosition()
        x=int((float(px)-20)/150)
        y=int((float(py)-50)/75)
        # falta controlar que la x y la y esten en los rangos
        if self.tabla[x][y][1][0]!="." and self.seleccion1!=(-1,-1) and self.tabla[x][y][0]==1:
            i=self.seleccion1[0]
            j=self.seleccion1[1]
            if self.tabla[x][y][1]== self.tabla[i][j][1][1::]:
                self.padre.sonido(2)
                self.tabla[x][y][0]=0
                self.tabla[i][j][0]=0
                self.seleccion1=(-1,-1)
                self.acertadas+=1
                if self.consonante in self.tabla[x][y][1]: # si contiene la consonante añade puntos a esta
                    self.P.puntosletras[self.padre.num_letra(self.consonante)]+=1
                if self.acertadas==8:
                    self.P.puntos+=self.P.incremento
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                    self.acertadas=0
                    self.padre.sonido(22)
                    self.completada=True
                    self.P.puntosjuegos[1]+=1
            else:
                self.padre.sonido(1)
                self.tabla[x][y][0]=1
                self.tabla[i][j][0]=1  
                self.seleccion1=(-1,-1)
                self.P.fallosjuegos[1]+=1
                if self.consonante in self.tabla[x][y][1]: # si contiene la consonante añade puntos a esta
                    self.P.fallosletras[self.padre.num_letra(self.consonante)]+=1
                
        if self.tabla[x][y][1][0]=="." and self.tabla[x][y][0]!=0:
            if self.seleccion1==(-1,-1):
                self.sonido.habla(self.tabla[x][y][1])
                self.tabla[x][y][0]=2
                self.seleccion1=(x,y)
            else: 
                if self.seleccion1==(x,y):
                    
                    self.sonido.habla(self.tabla[x][y][1])
                else:
                    i=self.seleccion1[0]
                    j=self.seleccion1[1]
                    self.tabla[i][j][0]=1 
                    
                    self.sonido.habla(self.tabla[x][y][1])
                    self.tabla[x][y][0]=2
                    self.seleccion1=(x,y)
                    
        self.Refresh()
  
    def Ayuda1(self,event):
        diesto=u'Pulsa en las casillas azules y escucha. Después únelas con las amarillas'
        self.sonido.habla(diesto)
        event.Skip()
    
    def Juego(self):
        self.padre.sonido(4)
        self.inicializatabla()
        self.Show()
        self.padre.Unbind (wx.EVT_TIMER)
        
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego1)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda1)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar1 )

        self.Bind(wx.EVT_PAINT, self.PaintJuego1)
        self.Bind (wx.EVT_LEFT_DOWN,self.MotorJuego1)
        
        
        self.Refresh()
        
     
