#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de Pinchar en los dibujos que empicen por la letra escrita
#
#

import wx
import codecs
import sys
import os
import random
import time


class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [3,0,u'Gontzal Uriarte',u'Empieza por...'] )
        self.tabla=[[1, '',''],[1, '',''],[1, '',''],[1, '',''],[1, '','']]
        self.solucion=""
        self.letra="a"
        self.casoscorrectos=0
        self.casosacertados=0
        
    def Terminar3(self,event):
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON) 
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        

        event.Skip()

    def Ayuda3     (self,event=None):        
        #ayudamos diciendo la siguiente sílaba
        self.sonido.habla(u'Pincha en los dibujos que empiecen por la letra del cuadro amarillo')
        self.Refresh()
        event.Skip()
        
        
    def Apoyo3(self,event=None):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<5:            
            if self.tabla[int(x)][0]==1 :        
                self.sonido.habla(self.tabla[int(x)][1].replace('-',''))
        event.Skip()

    def PaintJuego3 (self,event):
     
        dc=wx.PaintDC(self)
        #escalar la imagenes y dibujarlas
        for i in range(0,5):
            if self.tabla[i][0]==1:
                img = wx.Image((self.direccion+u"fotos//"+self.tabla[i][1]+".png"), wx.BITMAP_TYPE_ANY)
                img= img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
                img= wx.BitmapFromImage(img)
                dc.DrawBitmap(img,20+i*150,70,False)
        poscasosacertados=0
        for i in range(0,5):
            if self.tabla[i][0]==2:
                img = wx.Image((self.direccion+u"fotos//"+self.tabla[i][1]+".png"), wx.BITMAP_TYPE_ANY)
                img= img.Scale(50, 50, wx.IMAGE_QUALITY_HIGH)
                img= wx.BitmapFromImage(img)
                dc.DrawBitmap(img,560+poscasosacertados*60,330,False)
                poscasosacertados+=1
        #dibujar los bloques con el texto
        dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))    
        img = wx.Image((self.direccion+u"imagenes/bloqueamarillo.jpg"), wx.BITMAP_TYPE_ANY)
        img= img.Scale(150, 100, wx.IMAGE_QUALITY_HIGH)
        img= wx.BitmapFromImage(img)
        dc.DrawBitmap(img,400,300,True)
        dc.DrawText(self.P.maymin('Empieza por:'),50,320)
        dc.DrawText(self.P.maymin(self.letra),445,320)
        event.Skip()
 
    def MotorJuego3(self,event):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<5:            
            if self.tabla[int(x)][0]==1 :
                self.sonido.habla(self.tabla[int(x)][1].replace('-',''))

                if self.tabla[int(x)][2][0]==self.letra: 
                    time.sleep(1.5)
                    self.padre.sonido(2)
                    self.casosacertados+=1
                    self.tabla[int(x)][0]=2
                    self.P.puntosjuegos[3]+=1
                    self.P.puntosletras[self.padre.num_letra(self.letra)]+=1
                    
                else:
                    time.sleep(1.5)
                    self.padre.sonido(1)
                    self.P.fallosjuegos[3]+=1
                    self.P.fallosletras[self.padre.num_letra(self.letra)]+=1
                    
                if self.casosacertados==self.casoscorrectos: 
                    for elemento in self.tabla:
                        if elemento[0]==1: elemento[0]=0
                    self.Refresh()
                    time.sleep(1)
                    self.padre.sonido(22)
                    self.P.puntos+=self.P.incremento
                    self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                    
        self.Refresh()
        event.Skip()
    
        
    def MainJuego3(self,event):
        print "motor"
        self.inicializar()
        event.Skip()
    
    def Juego (self):
        
        self.padre.sonido(4)        
        self.Show()
        self.SetBackgroundColour('Blue')
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar3 )
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego3)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda3)

        self.Bind(wx.EVT_PAINT, self.PaintJuego3)
        self.Bind (wx.EVT_LEFT_DOWN,self.MotorJuego3)  
        self.Bind(wx.EVT_RIGHT_DOWN,self.Apoyo3)
        
        self.inicializar()
        
    def inicializar(self):
        # busca al menos dos palabras que empiezen por una letra de la tabla dificultades
        # Atencion si no encuentra ninguna la letra 'a' se toma por defecto.
        encontrados=0
        while encontrados<2:
            self.letra=random.choice(self.P.dificultades)
            empiezanconlaletra=[]
            for i in range(0,len(self.P.tabla)):    
                if self.P.tabla[i][0] == self.letra:
                    empiezanconlaletra.append(self.P.tabla[i])
                    encontrados+=1
        #introduciendo las palabras encontradas 
        for i in range(0,2):
            self.tabla[i][1]= random.choice(empiezanconlaletra)
            self.tabla[i][2]= self.tabla[i][1].replace('-','')
            self.tabla[i][0]= 1
        
        # introducimos algunas palabras al azar
        for i in range(2,5):
            self.tabla[i][1]= random.choice(self.P.tabla)
            self.tabla[i][2]= self.tabla[i][1].replace('-','')
            self.tabla[i][0]= 1
         
        # mareamos la tabla para que no esten siempre en el mismo lado.
        random.shuffle(self.tabla)
        self.casosacertados=0
        self.casoscorrectos=0
        for i in range(0,5):
            if self.tabla[i][2][0] == self.letra: 
                self.casoscorrectos+=1
        self.Refresh()
