#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# Pincha la palabra que corresponde al dibujo.
#
# 


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [11,2,u'Gontzal Uriarte',u'Eligir la palabra que corresponda al dibujo'] )
        self.palabra=""
        self.archivo=""
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Img_x=""
        self.Img_y=""
        self.completada=False
        self.py=0;self.px=0;
        self.Cuadro_x=[1,2,3,4,5,6,7,8,9]
        self.Cuadro_y=[1,2,3,4,5,6,7,8,9]
        self.tabla=[]
        self.solucion=-1
        
    def inicializar(self):
        self.completada=False
        self.SetBackgroundColour('Blue')
        # busca una palabra que corresponda a las caracteristicas de P.letras
        self.tabla=[]
        while len(self.tabla)<6:
            self.letra=random.choice(self.P.dificultades)
            self.tabla=filter(lambda s: self.letra in s,self.P.tabla)
        
        random.shuffle(self.tabla)       
        self.palabra=self.tabla[0]
        for i in range(0,len(self.tabla)-6):
            self.tabla.pop()
        random.shuffle(self.tabla)
        self.tabla=map(lambda s: s.replace('-','') ,self.tabla)
        self.archivo=self.palabra
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.palabra=self.palabra.replace('-','')
        self.solucion=self.archivo.count('-')+1
        for i in range(0,6):
            self.Cuadro_x[i]=range(400,700)
            self.Cuadro_y[i]=range(100+(i*50),150+(i*50))
        self.Img_x=range(100,100+150)
        self.Img_y=range(100,100+150)
        
    def PaintJuego35(self,event):
        dc=wx.PaintDC(self)

        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.SetBrush(wx.Brush('Yellow'))
            
            for i in range(0,6):
                dc.DrawRectangle(self.Cuadro_x[i][0], self.Cuadro_y[i][0], 300, 50)
                dc.DrawText(self.tabla[i],self.Cuadro_x[i][0]+10, self.Cuadro_y[i][0]+10)
                
            dc.DrawRectangle(150-20,150-20,150+40,150+40)
            dc.DrawBitmap(self.Img,150,150)
            dc.DrawText(self.P.maymin(u'Elige la palabra que le corresponde:'),100,40)
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,100,450,300)
            dc.DrawBitmap(self.Img,350,150)
            dc.DrawText(self.P.maymin(self.archivo.replace('-','')),440-len(self.archivo)*10,320)
            
        event.Skip()
     
        
    def MJclic35(self,event):
        
        self.px,self.py= event.GetPosition()
        if not self.completada:
            eleccion=-1  
            for i in range(0,6):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    eleccion=i

            if self.tabla[eleccion]== self.palabra.replace('-','') :
                self.completada=True
                self.padre.sonido(22)
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                time.sleep(1)
                self.sonido.habla(self.palabra)
                self.P.puntosjuegos[11]+=1
                self.P.puntosletras[self.padre.num_letra(self.letra)]+=1
            elif eleccion>=0:  # es mayor que -1, no ha sido correcta y ha elegido alguna respuesta 
                self.fallos+=1
                self.padre.sonido(1)    
                self.P.fallosjuegos[11]+=1
                self.P.fallosletras[self.padre.num_letra(self.letra)]+=1
        self.Refresh()
        event.Skip()        
        
    def MainJuego35(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()

    def Apoyo35(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)
        event.Skip()
        
    def Terminar35(self,event):
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)       
        
        
        event.Skip()

    def Ayuda35(self,event):
        self.sonido.habla('Pincha en la palabra que corresponde al dibujo')
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego35)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda35)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar35)  
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo35)
        self.Bind(wx.EVT_PAINT, self.PaintJuego35)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic35)
        
        self.padre.sonido(4)
        self.Refresh()
        self.Show()
