#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de introducir las letras dentro de las palabras
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido        
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append([12,0,u'Gontzal Uriarte',u'Introducir las letras dentro de las palabras'] )
        self.palabraconstruida=""
        
        self.tomado=-1
        self.archivo=""
        self.letras=[["",1],["",1],["",1],["",1]]
        self.tabla=[["","","",0],["","","",0],["","","",0],["","","",0]] #palabra completa,pal. sin letra,letra,acertado
        self.fallos=0
        self.Img_=[1,2,3,4]
        self.completada=False
        self.primera=True
        self.py=0;self.px=0;
        self.Cuadro_x = []
        self.Cuadro_y = []
    
    def inicializar(self):
        self.letras=[["",1],["",1],["",1],["",1]]
        self.tabla=[["","","",0],["","","",0],["","","",0],["","","",0]] #palabra completa,pal. sin letra,letra,acertado 
        self.SetBackgroundColour('Blue')
        self.Cuadro_x = []
        self.Cuadro_y = []
        self.Circulo_x=[]
        self.Circulo_y=[]
        self.Cuadro_x.append (range(20,420)) ; self.Cuadro_x.append (range(450,850)) ; self.Cuadro_x.append (range(20,420)) ; self.Cuadro_x.append (range(450,850))
        self.Cuadro_y.append (range(50,150)) ; self.Cuadro_y.append (range(50,150)) ; self.Cuadro_y.append (range(170,270)) ; self.Cuadro_y.append (range(170,270))
        self.Circulo_x.append (range(270,330)) ; self.Circulo_x.append (range(270+70,270+70+60)) ; self.Circulo_x.append (range(270+140,270+140+60)) ; self.Circulo_x.append (range(270+210,270+210+60))
        self.Circulo_y.append (range(370,430)) ; self.Circulo_y.append (range(370,430)) ; self.Circulo_y.append (range(370,430)) ; self.Circulo_y.append (range(370,430))
        for i in range(0,4):
            self.letras[i][0]=random.choice(self.P.dificultades)
            encontrado=False
            while not encontrado:
                self.tabla[i][0]=random.choice(self.P.tabla)
                if self.letras[i][0] in self.tabla[i][0]:
                    encontrado=True
        
        for i in range(0,4):
            self.Img_[i]= wx.Image((self.direccion+"fotos//"+ self.tabla[i][0] +".png"), wx.BITMAP_TYPE_ANY)
            self.Img_[i]= self.Img_[i].Scale(100, 90, wx.IMAGE_QUALITY_HIGH)
            self.Img_[i]= wx.BitmapFromImage(self.Img_[i])
            self.tabla[i][0]=self.tabla[i][0].replace("-","")
            self.tabla[i][1]=self.tabla[i][0].replace(self.letras[i][0],"_"*len(self.letras[i][0]))
            self.tabla[i][2]=self.letras[i][0]
        random.shuffle(self.letras)
        self.completada=False    
        

    def PaintJuego12(self,event):
        dc=wx.PaintDC(self)
        dc.SetPen(wx.Pen('Brown',4))
        dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.SetBrush(wx.Brush('Red'));        dc.DrawRectangle(20,50,400,100); dc.DrawText(self.P.maymin(self.tabla[0][1]),140,75)
        dc.SetBrush(wx.Brush('Blue'));       dc.DrawRectangle(450,50,400,100); dc.DrawText(self.P.maymin(self.tabla[1][1]),580,75)
        dc.SetBrush(wx.Brush('Green'));      dc.DrawRectangle(20,170,400,100); dc.DrawText(self.P.maymin(self.tabla[2][1]),140,200)
        dc.SetBrush(wx.Brush('Orange'));     dc.DrawRectangle(450,170,400,100); dc.DrawText(self.P.maymin(self.tabla[3][1]),580,200)
        
        dc.DrawBitmap(self.Img_[0],25,55)
        dc.DrawBitmap(self.Img_[2],25,175)
        dc.DrawBitmap(self.Img_[1],455,55)
        dc.DrawBitmap(self.Img_[3],455,175)
            
        for i in range(0,4):
            if self.letras[i][1]==1:
                dc.SetBrush(wx.Brush('Yellow'))
                dc.DrawCircle(300+70*i,400,30)
                dc.DrawText(self.P.maymin(self.letras[i][0]),290+70*i,385)
            if self.letras[i][1]==0:
                dc.SetBrush(wx.Brush('White'))
                dc.DrawCircle(float(self.px)+30,float(self.py)+30,30)
                dc.DrawText(self.P.maymin(self.letras[i][0]),float(self.px)+20,float(self.py)+20)
        
        event.Skip()
     
    def MJmueve12(self,event):
        self.px,self.py= event.GetPosition()
        if self.px % 20 == 0 or self.py % 20 == 0 and self.tomado!=-1:
            self.Refresh()
        event.Skip()
        
    def MJclic12(self,event):
        self.px,self.py= event.GetPosition()
        # Comprobamos que haya hecho una eleccion
        for i in range(0,4):
            eleccion= False
            if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                eleccion = True
                break
        # Si no ha hecho ninguna eleccion suelta lo que tiene recogido y dejalo en su sitio
        if not eleccion and self.tomado>=0:
            self.letras [self.tomado][1]=1
            self.tomado=-1
            
            
        # Recoge el circulo
        for i in range(0,4):
            if  self.px in self.Circulo_x[i] and self.py in self.Circulo_y[i] and self.tomado==-1:                
                # desaparece la eleccion
                self.letras[i][1]=0
                # marcalo como tomado
                self.tomado=i     
                self.padre.sonido(2)
        # Si elige un cuadro comprueba la eleccion.
        for i in range(0,4):
            if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i] and self.tomado>=0:             
                if self.letras[self.tomado][0]==self.tabla[i][2] and self.tabla[i][3]==0:
                    self.letras[self.tomado][1]=2
                    self.tabla[i][1]=self.tabla[i][0]
                    self.tabla[i][3]=1
                    self.padre.sonido(2)
                    self.tomado=-1
                    self.P.puntosjuegos[12]+=1
                    self.P.puntosletras[self.padre.num_letra(self.letras[self.tomado][0])]+=1
                            
                elif self.letras[self.tomado][0]!=self.tabla[i][2] and self.tabla[i][3]==0:
                    self.padre.sonido(1)
                    self.fallos=self.fallos+1
                    self.P.fallosjuegos[12]+=1
                    self.P.fallosletras[self.padre.num_letra(self.letras[self.tomado][0])]+=1
                    
                    
        # Si esta todo acertado termina y aporta los puntos
        todoacertado=True
        for i in range(0,4):
            if self.tabla[i][3]==0:todoacertado=False
        if todoacertado and not self.completada:
                self.padre.sonido(22)
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                self.completada=True
                
        self.Refresh()
        event.Skip()
        
    def MainJuego12(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()
        
    def Apoyo12(self,event):
        event.Skip()
        
    def Terminar12(self,event):
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind (wx.EVT_PAINT)
        self.Unbind (wx.EVT_MOTION)
        self.Unbind (wx.EVT_LEFT_DOWN)
        self.Hide()
        self.padre.Panel_ejercicios.Show()
        self.padre.pantalla=1 #pantalla de ejercicios
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        event.Skip()

    def Ayuda12(self,event):
        self.sonido.habla(' Introduce estas letras dentro de sus palabras.')
        event.Skip()
        
    
        
    def Juego(self):
        self.inicializar()
        
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego12)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda12)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar12)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo12)
        self.Bind (wx.EVT_PAINT, self.PaintJuego12)
        self.Bind (wx.EVT_MOTION,self.MJmueve12)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic12)
        self.SetFocus()
        self.Show()
        self.padre.sonido(4)
        self.Refresh()
        
        



