#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de 
# Eligir una sílaba amarilla o naranja.Las amarillas suenan ca,que,qui,co,cu. 
# Las naranjas suenan za,ze,zi,zo,zu. Utiliza el boton derecho del ratón para escucharlas
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [15,5,u'Gontzal Uriarte',u'Distinguir la Z de la C y la QU'] )
        self.palabra=""
        self.archivo="qui-nie-la"
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Img_x=""
        self.Img_y=""
        self.completada=False
        self.py=0;self.px=0;
        self.Cuadro_x=[0,1,2,3,4,5,6,7,8,9]
        self.Cuadro_y=[0,1,2,3,4,5,6,7,8,9]
        self.Tabla=[u"ca",u"que",u"qui",u"co",u"cu",u"za",u"ce",u"ci",u"zo",u"zu"]
        self.solucion=-1
        
    def inicializar(self):
        self.completada=False
        self.letra=random.choice(self.Tabla) # elige entre las letras ca,que,qui,co,cu
        i=0
        encontrado=False
        while not encontrado:
            i+=1
            self.archivo= random.choice(self.P.tabla)
            if self.letra in self.archivo:
                encontrado=True
            if i>100: 
                self.letra=random.choice(self.Tabla) # elige entre las letras ca,que,qui,co,cu
                i=0
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.palabra=self.archivo.replace('-','')
        self.solucion=self.Tabla.index(self.letra)

        for i in range(0,5):
            self.Cuadro_x[i]=range(50,200)
            self.Cuadro_y[i]=range((75*i)+50,(75*i)+125)
        for i in range(5,10):
            self.Cuadro_x[i]=range(700,850)
            self.Cuadro_y[i]=range((75*(i-5))+50,(75*(i-5))+125)
            
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        
    def PaintJuego15(self,event):
        dc=wx.PaintDC(self)
        
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.SetBrush(wx.Brush('Yellow'))
            for i in range(0,10):
                dc.SetBrush(wx.Brush('Yellow' if (i<5) else 'Orange'))
                dc.DrawRectangle(self.Cuadro_x[i][0] ,self.Cuadro_y[i][0] ,75, 75)
                dc.DrawText(self.Tabla[i],self.Cuadro_x[i][0]+10,self.Cuadro_y[i][0]+20)
            
            dc.DrawRectangle(350,100,150,150)
            dc.DrawBitmap(self.Img,350,100)
            dc.DrawText(self.P.maymin(self.palabra.replace(self.letra,'__')),350,300)
            dc.DrawText(self.P.maymin(u'Elige la sílaba correcta'),250,50)
            
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,100,450,300)
            dc.DrawBitmap(self.Img,350,150)
            dc.DrawText(self.P.maymin(self.palabra),440-len(self.palabra)*10,320)
        event.Skip()
     
        
    def MJclic15(self,event):
        self.px,self.py= event.GetPosition()
        
        if not self.completada:
            eleccion=-1
            for i in range(0,10):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    eleccion=i
                    self.sonido.habla(self.Tabla[eleccion])
                    break    
            if eleccion == self.solucion:
                self.completada=True
        
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                self.padre.sonido(22)
                time.sleep(1)
                self.sonido.habla(self.palabra)
                self.P.puntosjuegos[15]+=1
            elif eleccion>=0:
                self.fallos+=1
                self.padre.sonido(1)    
                self.P.fallosjuegos[15]+=1
        self.Refresh()
        event.Skip()        
        
    def MainJuego15(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()

    def Apoyo15(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)
        for i in range(0,10):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    self.sonido.habla(self.Tabla[i])
                    break    
        event.Skip()
        
    def Terminar15(self,event):
        
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON) 
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        event.Skip()

    def Ayuda15(self,event):
        self.sonido.habla(u'Elige una sílaba amarilla o naranja.Las amarillas suenan ca,que,qui,co,cu. Las naranjas suenan za,ze,zi,zo,zu. Utiliza el boton derecho del ratón para escucharlas')
        
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.SetBackgroundColour('Blue')
        self.Show()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego15)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda15)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar15)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo15)
        self.Bind(wx.EVT_PAINT, self.PaintJuego15)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic15)
        self.padre.sonido(4)
        self.Refresh()
