#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de SEPARAR LA FRASE CON ESPACIOS
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [17,3,u'Gontzal Uriarte',u'Separa las palabras de una frase con espacios'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.FraseSE=""
        self.Tablalong=[]
        self.dicho=False
        
    def inicializar(self):
        self.SetFocus()
        self.dicho=False
        self.completada=False
        self.SetBackgroundColour('Blue')
        Terminado=False
        while not Terminado:
            self.Frase=random.choice(self.P.Frases)
            if len(self.Frase)<40: Terminado=True

        self.FraseSE=self.Frase.replace(' ','')
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        self.corregir.Show()
        
    def PaintJuego17(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))    
        self.Tablalong=[]
        for i in range(0,len(self.FraseSE)):
            self.Tablalong.append(dc.GetTextExtent(self.P.maymin(self.FraseSE[:i:])))    
        self.Tablalong.append(dc.GetTextExtent(self.P.maymin(self.FraseSE)))    
        
        
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetBrush(wx.Brush('Yellow'))
            dc.DrawRectangle(50,200,750,150)
            dc.DrawText(self.P.maymin(self.FraseSE),70,250)    
            dc.DrawText('E'+self.P.maymin(u'sta frase contiene:'+str(self.Frase.count(' '))+u' espacios.'),70,100)    
            dc.DrawText('P'+self.P.maymin(u'incha en el inicio de cada palabra.'),70,130)    
            
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(50,100,750,200,20)
            dc.DrawText(self.P.maymin(self.Frase),(50+750)/2-(self.Tablalong[-1][0]/2),190)
            if not self.dicho:
                self.dicho=True
                self.padre.sonido(22)
                
        event.Skip()
     
        
    def MJclic17(self,event):
        self.px,self.py= event.GetPosition()    
        for i in range(1,len(self.FraseSE)+1):
            if self.px>=self.Tablalong[i-1][0]+70 and self.px<=self.Tablalong[i][0]+70:
                self.FraseSE=self.FraseSE[:i-1:]+' '+self.FraseSE[i-1::]
       
        self.padre.Refresh()
        event.Skip()        
        
    def MainJuego17(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.padre.Refresh()  
        self.SetFocus()
        event.Skip()
        
    def MJtecla17(self,event):
        tecla=event.GetKeyCode()
        if tecla==wx.WXK_BACK and not self.completada:
            for i in range(0,len(self.FraseSE)):
                lugar=self.FraseSE.find(' ',len(self.FraseSE)-i)
                if lugar!=-1: 
                    self.FraseSE=self.FraseSE[:lugar:]+self.FraseSE[lugar+1::]
                    break
                
            self.padre.Refresh()
        event.Skip()
        
    def Apoyo17(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar17(self,event):
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind(wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_MOTION)
        self.corregir.Unbind(wx.EVT_CHAR)
        self.corregir.Destroy()
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        event.Skip()

    def Ayuda17(self,event):
        self.sonido.habla(u'Separa las palabras de esta frase. Pincha en la primera letra de cada palabra para introducir un espacio:  '+self.Frase[:-2:])
        self.SetFocus()
        event.Skip()
    
    
    def Corregir17(self,event):
        if not self.completada:
            if self.Frase == self.FraseSE:
                self.completada = True
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.P.puntosjuegos[17]+=1
                self.fallos=0
                self.corregir.Hide()
                
            elif self.FraseSE !=self.Frase:
                self.fallos+=1
                self.FraseSE=self.Frase.replace(' ','')
                self.padre.sonido(1)    
                self.P.fallosjuegos[17]+=1
            self.Refresh()
        self.SetFocus()
        event.Skip()
 
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(350,330),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir17)
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego17)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda17)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar17)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo17)
        self.Bind(wx.EVT_PAINT, self.PaintJuego17)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic17)
        self.Bind (wx.EVT_MOTION,lambda s: self.SetFocus())
        self.corregir.Bind (wx.EVT_CHAR,self.MJtecla17)
        self.SetFocus()
        self.padre.sonido(4)
        self.Refresh()        
        self.Show()
