#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de disparar contra las inversiones.
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520),style=wx.WANTS_CHARS)
        self.sonido=Sonido
        self.padre=Padre
        self.P=Palabras
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [19,6,u'Gontzal Uriarte',u'Disparar contra las inversiones'] )
        self.pantalla=[]
        self.tomado=False
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.primera=True
        self.obj_x=0
        self.obj_y=400
        self.bala_x=0
        self.bala_y=0
        self.disparo=False
        self.tiempo=0
        self.silabas=[['se','es'],['le','el'],['ar','ra'],['mi','im'],['no','on'],['za','az'],['par','pra'],['ple','pel'],['tre','ter'],['gru','gur'],['fa','af'],['bre','ber'],['bel','ble']]
        self.eleccion=random.randint(0,len(self.silabas)-1)
        self.elec_part=random.randint(0,1)
        a=self.silabas[self.eleccion][self.elec_part]
        b=self.silabas[self.eleccion][0 if (self.elec_part==1) else 1]
        self.linea=[[a,[50,10],1],[a,[150,10],1],[a,[250,10],1],[a,[350,10],1],[a,[450,10],1],[a,[550,10],1],[a,[650,10],1],[a,[750,10],1]]     
        pos=random.randint(0,7)
        self.linea[pos][0]=b
        self.linea.append(pos)
        self.tabla=[self.linea]
        self.puntos=0
        self.izquierda=False
        self.derecha=True
        self.nivel=0
        self.fallo=False
        
    def PaintJuego19(self,event):
        dc=wx.PaintDC(self)
        if not self.completada:
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(self.obj_x,self.obj_y,100,50,10)
            dc.DrawText(str(self.puntos),self.obj_x+30,self.obj_y+15)
            dc.SetPen(wx.Pen('Red',10))
            dc.DrawLine(self.bala_x,self.bala_y,self.bala_x,self.bala_y+20)
            dc.SetPen(wx.Pen('Blue',6))
            dc.SetBrush(wx.Brush('Yellow'))
            if len(self.tabla)>0:
                for i in range(0,8):                        
                    dc.DrawRectangle(self.tabla[0][i][1][0], self.tabla[0][i][1][1],80,50)
                for j in range (0,len (self.tabla)):
                    for i in range(0,8):                        
                        ancho,alto=dc.GetTextExtent(self.tabla[j][i][0])
                        dc.DrawText(self.P.maymin(self.tabla[j][i][0]),self.tabla[j][i][1][0]+40-ancho/2, self.tabla[j][i][1][1]+10)
        else:
            dc.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,150,500,150)
            dc.DrawText(self.P.maymin(u'Estupendo! '+str(self.puntos)+' puntos'),250,200)
        event.Skip()

    def MotorJuego19(self,event):
        tecla = event.GetKeyCode()
     
        if tecla==wx.WXK_CONTROL and not self.completada and not self.disparo:
            self.bala_y=self.obj_y-10
            self.bala_x=self.obj_x+50
            self.disparo=True
            
            self.fallo=False
            
        if tecla==wx.WXK_LEFT and not self.completada:
            self.izquierda=True
            self.derecha=False
            
        if tecla==wx.WXK_RIGHT and not self.completada:
            self.derecha=True
            self.izquierda=False
            
        if tecla==wx.WXK_UP and not self.completada:
            pos_acertar=self.tabla[0][8]
            self.sonido.habla(u'Busca '+self.tabla[0][pos_acertar][0])
        self.Refresh()
        event.Skip()
        
    def MainJuego19(self,event):
        self.inicializar()
        self.completada=False
        self.padre.sonido(4)
        self.padre.tiempo.Stop()
        self.padre.tiempo.Start(40)
        self.Refresh()        
        event.Skip()
        
        
    def Terminar19(self,event):
        self.padre.tiempo.Stop()
        self.Unbind(wx.EVT_TIMER)
        self.padre.tiempo.Destroy()
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind(wx.EVT_KEY_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_MOTION)
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)

        event.Skip()

    def Ayuda19(self,event):
        self.sonido.habla(u'Junta las sílabas iguales')
        self.SetFocus()
        event.Skip()
        
    def ontimer(self,event):
        if not self.completada:
            if self.puntos%10==0 and self.puntos>0:
                self.tabla=[]
                self.tiempo=100
                self.sonido.habla('Nivel '+str(self.puntos/10))
                self.puntos+=1
                self.nivel+=1
                
            self.tiempo+=1
            if self.tiempo>((50-self.puntos)+(self.nivel*2))*len(self.tabla):
                for j in range(0,len(self.tabla)):
                    for i in range(0,8):
                        self.tabla[j][i][1][1]+=50
                self.eleccion=random.randint(0,len(self.silabas)-1)
                self.elec_part=random.randint(0,1)
                a=self.silabas[self.eleccion][self.elec_part]
                b=self.silabas[self.eleccion][0 if (self.elec_part==1) else 1]
                self.linea=[[a,[50,10],1],[a,[150,10],1],[a,[250,10],1],[a,[350,10],1],[a,[450,10],1],[a,[550,10],1],[a,[650,10],1],[a,[750,10],1]]
                pos=random.randint(0,7)
                self.linea[pos][0]=b
                self.linea.append(pos)
                self.tabla.append(self.linea)
                self.tiempo=0
            
            if self.izquierda:
                self.obj_x-=20
                if self.obj_x<10: 
                    self.derecha=True
                    self.izquierda=False
                
                
            if self.derecha:
                self.obj_x+=20
                if self.obj_x>820: 
                    self.derecha=False
                    self.izquierda=True
                    
            
            
            if self.disparo:
                self.bala_y-=50
        
            if self.bala_y<-20 and not self.fallo:
                self.disparo=False
                if self.puntos>0:
                    self.puntos-=1
                    self.fallo=True
                    self.P.fallosjuegos[19]+=1
                    
            self.Refresh()
            if len(self.tabla)>0:
                pos_acertar=self.tabla[0][8]
                if self.bala_x>self.tabla[0][pos_acertar][1][0]-10 and self.bala_x<self.tabla[0][pos_acertar][1][0]+90 and self.bala_y<self.tabla[0][pos_acertar][1][1]:
                    self.bala_y=-10
                    self.bala_x=-10
                    self.tabla.pop(0)
                    self.padre.sonido(5)
                    self.puntos+=1
                    self.disparo=False
                    self.P.puntosjuegos[19]+=1
                    
        if len(self.tabla)>6:
            self.completada=True
        event.Skip()
        
        
    def inicializar(self):
        self.pantalla=[]
        self.tomado=False
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.primera=True
        self.obj_x=0
        self.obj_y=400
        self.bala_x=0
        self.bala_y=0
        self.disparo=False
        self.tiempo=0
        self.silabas=[['se','es'],['le','el'],['ar','ra'],['mi','im'],['no','on'],['za','az'],['par','pra'],['ple','pel'],['tre','ter'],['gru','gur'],['fa','af'],['bre','ber'],['bel','ble']]
        self.eleccion=random.randint(0,len(self.silabas)-1)
        self.elec_part=random.randint(0,1)
        a=self.silabas[self.eleccion][self.elec_part]
        b=self.silabas[self.eleccion][0 if (self.elec_part==1) else 1]
        self.linea=[[a,[50,10],1],[a,[150,10],1],[a,[250,10],1],[a,[350,10],1],[a,[450,10],1],[a,[550,10],1],[a,[650,10],1],[a,[750,10],1]]     
        pos=random.randint(0,7)
        self.linea[pos][0]=b
        self.linea.append(pos)
        self.tabla=[self.linea]
        self.puntos=0
        self.izquierda=False
        self.derecha=True
        self.nivel=0
        self.fallo=False
        # Activar el evento del reloj        
        self.padre.tiempo.Start(40)
     

    def Juego(self):
        self.inicializar()
        
        
        self.bloque = wx.Image((self.direccion+"imagenes//blokeamarillo.jpg"), wx.BITMAP_TYPE_ANY)
        self.bloque= self.bloque.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.bloque= wx.BitmapFromImage(self.bloque)
        
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego19)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda19)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar19)
        
        self.Bind(wx.EVT_PAINT, self.PaintJuego19)
        self.Bind (wx.EVT_KEY_DOWN,self.MotorJuego19)
        self.Bind (wx.EVT_MOTION,lambda s: self.SetFocus())
        self.SetFocus()
        self.Show()
        self.SetBackgroundColour('blue')
        self.padre.sonido(4)   
        self.Refresh()
        
        



