#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de distinguir palabras entre b y v
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [21,5,u'Gontzal Uriarte',u'Ortografía: B y V'] )
        self.palabra=""
        self.primera= True
        self.archivo=""
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Imagen=""
        self.Imagen_x=300
        self.Imagen_y=350
        self.archivo=""
        self.completada=False
        self.py=0;self.px=0;
        self.bloque=[1,2,3,4,5,6]
        self.solucion=-1
        self.tiempo=0
        self.nivel=0
        encontrado=False
        self.letra='v'
        self.memoriza=True
        
    def inicializar(self):
        # Activar el evento del reloj
        self.padre.tiempo.Start(40)
        self.SetFocus()
        self.puntuada=False
        self.memoriza=True
        self.completada=False
        self.tiempo=0
        self.puntos=0
        self.puntuacion=0
        self.SetBackgroundColour('Blue')
       
        
        for i in range(0,3):                
            encontrado=False
            while not encontrado:
                self.palabra=random.choice(self.P.tabla)
                if ("b" in self.palabra) and ("v" not in self.palabra):
                    encontrado = True
            self.archivo=self.palabra
            self.Img= wx.Image((self.direccion+"fotos/"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
            self.Img= self.Img.Scale(70, 70, wx.IMAGE_QUALITY_HIGH)
            self.Img= wx.BitmapFromImage(self.Img)
            self.palabra=self.palabra.replace('-','')
            self.bloque[i]=[self.Img,self.palabra,10+(i*80),0,True]
            
        for i in range(3,6):                    
            encontrado=False
            while not encontrado:
                self.palabra=random.choice(self.P.tabla)
                if ("v" in self.palabra) and ("b" not in self.palabra):
                    encontrado = True
            self.archivo=self.palabra
            self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
            self.Img= self.Img.Scale(70, 70, wx.IMAGE_QUALITY_HIGH)
            self.Img= wx.BitmapFromImage(self.Img)
            self.palabra=self.palabra.replace('-','')
            self.bloque[i]=[self.Img,self.palabra,10+(i*80) ,0,True]

        
        
    def PaintJuego21(self,event):
        dc=wx.PaintDC(self)
        
        if not self.completada:
            if self.memoriza:
                for i in range(0,3):
                    dc.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
                    dc.DrawBitmap(self.bloque[i][0], 40, 40+(i*100))
                    dc.DrawText(self.bloque[i][1],120,60+(i*100))
                for i in range(3,6):
                    dc.SetFont(wx.Font(20, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
                    dc.DrawBitmap(self.bloque[i][0], 400, 40+((i-3)*100))
                    dc.DrawText(self.bloque[i][1],480,60+((i-3)*100))
                    
            if not self.memoriza:            
                dc.SetPen(wx.Pen('Brown',4))
                dc.SetFont(wx.Font(50, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
                dc.SetBrush(wx.Brush('Yellow'))
                dc.DrawRectangle(self.Imagen_x,self.Imagen_y,50,60)
                dc.DrawText(self.P.maymin(self.letra),self.Imagen_x+5,self.Imagen_y+5)     
                for i in range(0,6):
                    if self.bloque[i][4]:
                        dc.DrawBitmap(self.bloque[i][0], self.bloque[i][2] , self.bloque[i][3])
            
        else:
            
            self.padre.tiempo.Stop()
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.DrawRectangle(300,100,350,200)
            dc.DrawText("¡Muy bien! " + str(self.puntos)+ " puntos",310,150)     
            if not self.puntuada:
                self.padre.sonido(22)
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)                
                self.puntuada= True
            
        event.Skip()
    
    def ontimer(self,event):    
        
        if not self.completada and not self.memoriza:
            for i in range(0,6):
                self.bloque[i][3]+=1
                if self.Imagen_x in range(self.bloque[i][2],self.bloque[i][2]+70) and self.Imagen_y in range(self.bloque[i][3],self.bloque[i][3]+70) and self.bloque[i][4]:
                    if self.letra in self.bloque[i][1]:
                        self.bloque[i][4]=False
                        self.padre.sonido(5)
                        self.letra= 'b' if (self.letra=='v') else 'v'
                        self.puntos+=1
                        self.completada=True
                        for j in range(0,6):
                            self.bloque[j][3]=0
                            if self.bloque[j][4]:
                                self.completada=False

                if self.bloque[i][3]>400:
                    self.bloque[i][3]=0
        self.Refresh()
        event.Skip()
    
    def MotorJuego21(self,event):
        self.SetFocus()
        tecla = event.GetKeyCode()
        
        if self.memoriza: 
            random.shuffle(self.bloque)
            self.memoriza=False
            for i in range(0,6):
                self.bloque[i][2]=10+(i*80)
                
        
            
        if not self.completada and not self.memoriza:
            if tecla==wx.WXK_LEFT and self.Imagen_x>10:
                self.Imagen_x-=15
            
            if tecla==wx.WXK_RIGHT and self.Imagen_x<700:
                self.Imagen_x+=15
            
            if tecla==wx.WXK_DOWN:
                for i in range(0,6):
                    self.bloque[i][3]+=10
             
        self.Refresh()
        event.Skip()        
        
    def MainJuego21(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()
        self.SetFocus()
        event.Skip()

    def Apoyo21(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar21(self,event):
        
        self.padre.tiempo.Stop()
        self.Unbind(wx.EVT_TIMER)
        self.padre.tiempo.Destroy()
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_KEY_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_RIGHT_DOWN)
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        event.Skip()

    def Ayuda21(self,event):
        self.sonido.habla('Memoriza estas palabras con b y v. Pulsa una tecla. Después muevela a la palabra correspondiente')
        self.SetFocus()
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego21)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda21)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar21)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo21)
        self.Bind (wx.EVT_PAINT, self.PaintJuego21)
        self.Bind (wx.EVT_KEY_DOWN,self.MotorJuego21)
        self.SetFocus()
        self.padre.sonido(4)
        self.Refresh()
        self.Show()
        
        

