#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de rr y r
#
#


import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [22,5,u'Gontzal Uriarte',u'Se escribe con r o rr'] )
        self.palabra=""
        self.archivo=""
        self.letra=""
        self.fallos=0
        self.Img=""
        self.Img_x=""
        self.Img_y=""
        self.completada=False
        self.py=0;self.px=0;
        self.Cuadro_x=[0,1,2,3,4,5,6,7,8,9]
        self.Cuadro_y=[0,1,2,3,4,5,6,7,8,9]
        # tablas de eleccion de palabras, self.Tabla tiene más rr porque quiero privilegiar esa opcion
        self.Tabla=[u"rr",u"-ra",u"-re",u"-ri",u"-ro",u"-ru",u"rr",u"rr",u"rr",u"rr",u"rr",u"rr",u"rr",u"rr",u"rr"]
        self.Traductor={u"rr":u"r", u"-ra":u"rra" , u"-re":u"-rre", u"-ri":u"-rri", u"-ro":u"-rro", u"-ru":u"-rru"}
        self.TablaPal=["",""]
        self.solucion=-1
        
    def inicializar(self):
        self.completada=False
        self.SetBackgroundColour('Blue')
        self.letra=random.choice(self.Tabla) # elige entre las letras c,qu
        i=0
        encontrado=False
        while not encontrado:
            i+=1
            self.archivo=random.choice(self.P.tabla)
            if self.letra in self.archivo:
                encontrado=True
            if i>50: 
                self.letra=random.choice(self.Tabla) # elige entre las letras c,qu
                i=0
        self.Img= wx.Image((self.direccion+"fotos//"+ self.archivo +".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        
        self.TablaPal[0]=self.archivo
        self.TablaPal[1]=self.archivo.replace(self.letra,self.Traductor[self.letra])
        self.TablaPal[0]=self.TablaPal[0].replace('-','')
        self.palabra=self.TablaPal[0]
        self.TablaPal[1]=self.TablaPal[1].replace('-','')
        
        random.shuffle(self.TablaPal)
        for i in range(0,2):
            if self.TablaPal[i]==self.palabra:
                self.solucion=i
                break
            
        self.Cuadro_x[1]=range(50,350)
        self.Cuadro_y[1]=range(300,400)
        self.Cuadro_x[0]=range(500,800)
        self.Cuadro_y[0]=range(300,400)
            
        self.Img_x=range(350,350+150)
        self.Img_y=range(100,100+150)
        self.SetFocus()
        
    def PaintJuego22(self,event):
        dc=wx.PaintDC(self)
        
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed"))             
            dc.SetBrush(wx.Brush('Yellow'))
            for i in range(0,2):
                dc.SetBrush(wx.Brush('Yellow'))
                dc.DrawRoundedRectangle(self.Cuadro_x[i][0] ,self.Cuadro_y[i][0] ,self.Cuadro_x[i][-1]-self.Cuadro_x[i][0] , self.Cuadro_y[i][-1]-self.Cuadro_y[i][0],20)
                longitud,anchura=dc.GetTextExtent(self.TablaPal[i])
                dc.DrawText(self.P.maymin(self.TablaPal[i]),(self.Cuadro_x[i][0]+self.Cuadro_x[i][-1])/2-longitud/2,(self.Cuadro_y[i][-1]+self.Cuadro_y[i][0])/2-anchura/2 )

            dc.DrawRectangle(350,100,150,150)
            dc.DrawBitmap(self.Img,350,100)
            dc.DrawText(u'E'+self.P.maymin(u'lige la palabra correcta'),250,50)
            
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRectangle(200,100,450,300)
            dc.DrawBitmap(self.Img,350,150)
            dc.DrawText(self.P.maymin(self.palabra),440-len(self.palabra)*10,320)
        event.Skip()
     
        
    def MJclic22(self,event):
        dc=wx.PaintDC(self.padre)
        self.px,self.py= event.GetPosition()
        
        if not self.completada:
            eleccion=-1
            for i in range(0,10):
                if self.px in self.Cuadro_x[i] and self.py in self.Cuadro_y[i]:
                    eleccion=i
                    self.sonido.habla(self.TablaPal[eleccion])
                    break    
            if eleccion == self.solucion:
                self.completada=True
                self.padre.sonido(22)
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.P.puntosjuegos[22]+=1
                self.fallos=0
            elif eleccion>=0:
                self.fallos+=1
                self.padre.sonido(1)    
                self.P.fallosjuegos[22]+=1
        self.Refresh()
     
        event.Skip()        
        
    def MainJuego22(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()
        
        event.Skip()

    def Apoyo22(self,event):
        self.px,self.py= event.GetPosition()
        if not self.completada:
            if (self.px in self.Img_x) and (self.py in self.Img_y):
                self.sonido.habla(self.palabra)
        
        event.Skip()
        
    def Terminar22(self,event):
        
        
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind(wx.EVT_RIGHT_DOWN)
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        
        
        event.Skip()

    def Ayuda22(self,event):
        self.sonido.habla(u'Elige la palabra correctamente escrita.')
        self.SetFocus()
        event.Skip()
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego22)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda22)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar22)  
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo22)
        self.Bind(wx.EVT_PAINT, self.PaintJuego22)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic22)
        self.SetFocus()
        self.padre.sonido(4)
        self.padre.Refresh()        
        self.Show()
