#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de acertar una palabra leyendo frases descriptivas.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy

class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [24,3,u'Gontzal Uriarte',u'Adivinar la palabra leyendo frases'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.ayudaletras=""
        self.Tablong=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.cogido=False
        self.FraseConstruida=""
     
        self.dicho=False
        self.contador=1
        self.activo=[]
        self.Img=""
        self.longitudfrase=0
        self.pistas=[]
        
    def inicializar(self):
        self.fallos=0
        self.contador=1
        self.completada=False
        self.SetBackgroundColour('Blue')
        self.Frase=random.choice(self.P.Adivinanzas)
        
        self.Frase=self.Frase [:-1:]
        self.pistas=self.Frase.split("/")
        self.corregir.Show()
        self.palabras.Show()     
        self.Img= wx.Image((self.direccion+"fotos//"+ self.pistas[0]+".png"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.pistas[0]=self.pistas[0].replace('-','')
        self.ayudaletras=len(self.pistas[0])*'-'
        self.palabras.SetValue('')
        self.palabras.SetFocus()
        
    def PaintJuego24(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(23, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.SetBrush(wx.Brush('Yellow'));        
        
        
        if not self.completada:
            for i in range (1,self.contador+1):
                dc.DrawRoundedRectangle(60,20+(i-1)*70,800,50,20)
                dc.DrawText(self.P.maymin(self.pistas[i]),70,30+(i-1)*70)
            dc.DrawText(self.P.maymin(u'Solución: '),20,450)    
            dc.SetFont(wx.Font(50, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawText(self.P.maymin(self.ayudaletras),200,360)
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetBrush(wx.Brush('White'));        
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(200,100,500,300,20)
            dc.DrawBitmap(self.Img,250,150)
            dc.DrawText(self.P.maymin(self.pistas[0]),450,200)
            
        event.Skip()
     
        
    def MJclic24(self,event):
        self.px,self.py= event.GetPosition()    
        event.Skip()        
        
    def MainJuego24(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()
                
    def Apoyo24(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar24(self,event):
        
        self.corregir.Destroy()
        self.palabras.Destroy()
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_PAINT)
 
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        event.Skip()

    def Ayuda24(self,event):
        self.sonido.habla(u'Adivina la palabra que describen estas frases.')
        event.Skip()
        
    def Corregir24 (self,event):
        if not self.completada:
            soluciondada= self.palabras.GetValue().lower() 
            solucionreal=self.pistas[0].lower()
            if  solucionreal== soluciondada:
                self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
                self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                self.fallos=0
                self.completada=True
                self.Refresh()
                self.padre.sonido(22)
                self.corregir.Hide()
                self.palabras.Hide()
                self.P.puntosjuegos[24]+=1
             
            else:
                self.padre.sonido(30)
                self.fallos+=1
                self.contador+=1
                cont=0
                self.P.fallosjuegos[24]+=1

                for i in solucionreal:
                    if i in soluciondada:
                        self.ayudaletras= self.ayudaletras[:cont] + i + self.ayudaletras[cont+1:]
                    cont+=1
                    
                if self.fallos==5: 
                    self.completada=True
                    self.corregir.Hide()
                    self.palabras.Hide()
                    
            self.palabras.SetValue('')
            self.palabras.SetFocus()
            self.Refresh()
        event.Skip()
        
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(550,430),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir24)
        self.palabras=wx.TextCtrl(id=wx.NewId(),name='palabras',parent=self,pos=wx.Point(200,430),size=wx.Size(300,60), style=wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        self.palabras.SetFont(wx.Font(43,wx.DEFAULT,wx.NORMAL,wx.BOLD,0,"Edelfontmed"))
        self.Img=wx.Image(self.direccion+'imagenes//120px-Play_icon.png',wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego24)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda24)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar24)  
        
        self.Bind(wx.EVT_PAINT, self.PaintJuego24)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic24)
        self.SetFocus()
        
        self.padre.sonido(4)
        self.Refresh()    
        self.Show()
