#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de adivinar a que imagen corresponde la palabra.
#
#

import wx
import codecs
import sys
import os
import random
import time


class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.sonido=Sonido
        self.P=Palabras
        self.padre=Padre
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [26,2,u'Gontzal Uriarte',u'Elegir la imagen que corresponde a la palabra.'] )
        self.img=["","","","",""]
        self.tabla=[[1, '',''],[1, '',''],[1, '',''],[1, '',''],[1, '','']]
        self.solucion=""
        self.letra="a"
        self.casoscorrectos=0
        self.casosacertados=0
        self.palabra=""
        self.palabraclave=""
        self.completada=False
        
    def Terminar26(self,event):
        
    
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind(wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_RIGHT_DOWN)
        
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        event.Skip()
   
    def PaintJuego26(self,event):
        dc=wx.PaintDC(self)
        
        for i in range(0,5):
            if self.tabla[i][0] ==1:
                dc.DrawBitmap(self.img[i],20+i*150,70,False)
        dc.SetFont(wx.Font(40, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        dc.DrawText(self.P.maymin(self.palabraclave),400-len(self.palabraclave)*10,300)
        event.Skip()
     
    def MotorJuego26(self,event):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if not self.completada:
            if y>70 and y<70+150 and x<5:            
                if self.tabla[int(x)][0]==1 :
                    self.sonido.habla(self.tabla[int(x)][1].replace("-",''))
                    if self.tabla[int(x)][1].replace("-","")==self.palabra: 
                        
                        for i in range(0,5): self.tabla[i][0]=2
                        self.tabla[int(x)][0]=1
                        self.P.puntos+=self.P.incremento
                        self.padre.Panel_control.progreso.SetValue(self.P.puntos)
                        self.completada=True
                        time.sleep(1)
                        self.padre.sonido(22)
                        self.P.puntosjuegos[26]+=1
                    else:
                        time.sleep(1)
                        self.padre.sonido(1)
                        self.P.fallosjuegos[26]+=1
                            
        self.Refresh()
        event.Skip()
        
    def MainJuego26(self,event):
        self.inicializar()
        self.Refresh()
        event.Skip()
        
    def Apoyo26(self,event):
        px,py= event.GetPosition()
        x=((float(px)-20)/150)
        y=((float(py)))
        if y>70 and y<70+150 and x<5:            
            if self.tabla[int(x)][0]==1 :
                self.sonido.habla(self.tabla[int(x)][1].replace("-",''))
        
        event.Skip()
    
    def Ayuda26(self,event):
        self.sonido.habla(u'Pincha en la imagen que le corresponda a la palabra '+self.palabra)
        event.Skip()
        
    def inicializar(self):
        self.SetBackgroundColour('Blue')
        self.completada= False
        for i in range(0,5):
            self.tabla[i][1]= random.choice(self.P.tabla)
            self.tabla[i][0]=1
            self.img [i]= wx.Image((self.direccion+"fotos//"+self.tabla[i][1]+".png"), wx.BITMAP_TYPE_ANY)
            self.img [i]= self.img[i].Scale(150, 150, wx.IMAGE_QUALITY_HIGH)
            self.img [i]= wx.BitmapFromImage(self.img[i])            
 
        # intenta unas 20 veces que la palabra generada exista 
        eleccion=random.choice([0,1,2,3,4])
        self.palabra=self.tabla[eleccion] [1].split('-')
        self.palabra="".join(self.palabra) # concatena la lista de silabas
        self.palabraclave=self.palabra
        
    def Juego(self):
        self.inicializar()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar26 )            
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego26)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda26)
        
        self.Bind(wx.EVT_PAINT, self.PaintJuego26)
        self.Bind (wx.EVT_LEFT_DOWN,self.MotorJuego26)  
        self.Bind(wx.EVT_RIGHT_DOWN,self.Apoyo26)
        
        self.Refresh()
        self.padre.sonido(4)
        self.Show()
        
        
        


        



