#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de copiar una frase.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [28,3,u'Gontzal Uriarte',u'Copiar frases'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.Palabras=[]
        self.Tabla=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.cogido=False
        self.FraseConstruida=""
        self.ListaFrascons=[]        
        self.dicho=False
        self.nivel=0
        self.activo=[]
        self.Img=""
        self.longitudfrase=0
        self.correcta=False
        
    def inicializar(self):
        self.padre.tiempo.Start(5000)
        self.SetBackgroundColour('Blue')
        self.correcta=False
        self.fallos=0
        self.completada=False
        self.dicho=False
        self.FraseConstruida=""
        self.ListaFrascons=[]
        Terminado=False
        cont=0
        while not Terminado:
            cont+=1
            self.Frase=random.choice(self.P.Frases)
            if (len(self.Frase)<30 + self.nivel and len(self.Frase)>20 + self.nivel) or (cont>1000):
                Terminado=True
                
        self.Frase=self.Frase [:-1:]
        self.Palabras=self.Frase.split(" ")
        self.longitudfrase=len(self.Palabras)
        for i in range(0,len(self.Palabras)):
            self.activo.append(True)
        self.Img_x=range(600,600+100)
        self.Img_y=range(70,70+100)
        self.corregir.Show()
        self.Texto.Show()
        
    def PaintJuego28(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(23, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        if not self.completada:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.SetTextForeground("blue")   
            dc.DrawRoundedRectangle(20,10,800,170,20)
            frases=["","",""]
            cont=0
            for i in range(0,len(self.Palabras)):
                frases[cont]+=self.Palabras[i]+' '
                long,anch=dc.GetTextExtent(frases[cont])
                if long>550:
                    cont+=1
            for i in range(0,3):
                dc.DrawText(frases[i],30,15+(i*50))            
        else:
            dc.SetFont(wx.Font(45, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawText(self.P.maymin('Correcto'),150,150)            
        event.Skip()
     

    def MJclic28(self,event):
        self.px,self.py= event.GetPosition()    
        if self.px in self.Img_x and self.py in self.Img_y:
            self.sonido.habla(self.Frase)
        event.Skip()        
        
    def MainJuego28(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()  
        
        event.Skip()
                
    def Apoyo28(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar28(self,event):
        
        self.corregir.Destroy()
        self.Texto.Destroy()
        self.padre.tiempo.Stop()
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        
        
        event.Skip()
        
    def ontimer(self,event):
        if not self.completada:
            pos=self.Texto.GetInsertionPoint()
            frase_usuario=list(self.Texto.GetValue())
            frase_correcta=list(self.Frase)
            fraseus="".join(frase_usuario)
            fraseco="".join(frase_correcta)
            # introduce los fallos de la frase en una tabla
            cont=0
            self.tabla=[]
            while cont<=len(frase_usuario)-1 and cont<=len(frase_correcta)-1:
                if frase_usuario[cont]!=frase_correcta[cont]:
                    self.tabla.append(cont)
                cont+=1
            
            if len(self.tabla)!=0 : # si existe algo escrito
                self.Texto.SetValue(''.join(frase_usuario))
                self.Texto.SetStyle(len(frase_correcta),0,wx.TextAttr("black","white"))
                frasedelcorrector=u'Corrigiendo.'
                self.P.fallosjuegos[28]+=0.3
                for i in self.tabla: # Marca en rojo los fallos
                    self.Texto.SetStyle(i+1,i,wx.TextAttr("Red",(245,245,255)))
                    if  frase_correcta[i] in u'áéíóúüÁÉÍÓÚ':
                        frasedelcorrector+=u'Cuidado con los acentos.'
                    if frase_correcta[i].lower() == frase_usuario[i]:
                        frasedelcorrector+=u'Cuidado con las mayúsculas.'
                    if  frase_correcta[i] in u'.,:?¿!¡':
                        frasedelcorrector+= u'Cuidado con signo de puntuación.'
                    if  frase_correcta[i] in u'hH':
                        frasedelcorrector+= u'Cuidado falta alguna h'
                        
                if len(frase_usuario)>len(frase_correcta): # marca cuando se ha pasado de largura
                    self.Texto.SetStyle(len(frase_correcta),len(frase_usuario),wx.TextAttr("Yellow","Black"))             
                
                self.Texto.SetInsertionPoint(pos)
                self.sonido.habla(frasedelcorrector)
            elif len(frase_usuario) == len(frase_correcta)-1 and len(self.tabla)==0:
                    self.sonido.habla(u'Falta el punto final.')
            elif ''.join(frase_usuario)==''.join(frase_correcta):
                self.sonido.habla(u'Creo que está bien. Pulsa el botón para corregir')
                #Escrita correctamente
                self.correcta=True
                self.P.puntosjuegos[28]+=1
            elif len(self.tabla)==0 and len(frase_usuario)>0:
                self.Texto.SetValue(''.join(frase_usuario))
                self.Texto.SetStyle(len(frase_correcta),0,wx.TextAttr("black","white"))
                self.Texto.SetInsertionPoint(pos)
        event.Skip()

    def Ayuda28(self,event):
        self.sonido.habla(u'Copia correctamente esta frase.')
        event.Skip()
        
    def Corregir28 (self,event):
        if self.correcta:           
            self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
            self.padre.Panel_control.progreso.SetValue(self.P.puntos)
            self.completada=True
            self.fallos=0
            self.nivel+=5
            self.completada=True
            self.Refresh()
            self.padre.sonido(22)
            self.Texto.SetValue('')
            self.corregir.Hide()
            self.Texto.Hide()
        event.Skip()
        
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(350,420),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir28)
        self.Texto = wx.TextCtrl(id=wx.NewId(), name='Texto', parent=self, pos=wx.Point(30,200),size=wx.Size(750,200),style=wx.TE_MULTILINE|wx.TE_PROCESS_ENTER|wx.TE_RICH2,value='')
        self.Texto.SetFont(wx.Font(30,wx.DEFAULT,wx.NORMAL,wx.BOLD,0,"Edelfontmed"))
        self.Img=wx.Image(self.direccion+'imagenes//120px-Play_icon.png',wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego28)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda28)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar28)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo28)
        self.Bind (wx.EVT_PAINT, self.PaintJuego28)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic28)
        
        self.SetFocus()
        self.padre.sonido(4)
        self.Refresh()    
        self.Show()
