#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata elegir las frases verdaderas.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy

class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [29,4,u'Gontzal Uriarte',u'¿Verdadero o Falso?'] )
        self.palabra=""
        self.archivo=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.Frase=""
        self.ayudaletras=""
        self.Tablong=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.cogido=False
        self.FraseConstruida=""
        self.dicho=False
        self.contador=1
        self.activo=[]
        self.Img=""
        self.Img_x=range (300,300+300)
        self.Img_y= range (10,200+10)
        self.longitudfrase=0
        self.pistas=[]
        self.eleccion=[]
        self.aciertos=0
        self.ampliarfoto=False
        self.Imga=""
        
    def inicializar(self):
        self.SetBackgroundColour('Blue')
        self.fallos=0
        self.Img_x=range (300,300+300)
        self.Img_y= range (10,200+10)
        self.ampliarfoto=False
        self.aciertos=0
        self.contador=1
        self.completada=False
        self.Frase=random.choice(self.P.Verdaderofalso)
        self.Frase=self.Frase [:-1:]
        self.pistas=self.Frase.split("/")
        self.corregir.Show()
        self.Imga= wx.Image((self.direccion+"imagenes//Verdaderofalso//Foto_"+ self.pistas[0]+".jpg"), wx.BITMAP_TYPE_ANY)
        self.Img= self.Imga.Scale(300, 200, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        self.pistas[0]=self.pistas[0].replace('-','')
        self.ayudaletras=len(self.pistas[0])*'-'
        for i in range(0,4):
            self.bloque_x.append(range (60,60+750))
            self.bloque_y.append(range (220+(i)*50, 270+(i)*50))
            self.eleccion.append('F')
        
    def PaintJuego29(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(23, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
       
        if not self.completada:
            if not self.ampliarfoto:
                for i in range (0,4):
                    dc.SetBrush(wx.Brush('Yellow' if (self.eleccion[i] == 'V') else 'Green'  ))
                    dc.DrawRoundedRectangle(60,220+(i)*50,750,50,20)
                    dc.SetTextForeground("Black")
                    dc.DrawText(self.P.maymin(self.pistas[i+1][0:self.pistas[i+1].find(".")+1:]),70,230+(i)*50)
                    dc.SetTextForeground("White")   
                    dc.DrawText(self.P.maymin(self.eleccion[i]),30,230+(i)*50)
                dc.DrawText( self.P.maymin(u'Has tenido ')+ str(self.fallos)+ self.P.maymin( u' fallos.'),100,430)    
                dc.DrawBitmap(self.Img,self.Img_x[0],self.Img_y[0])
            else:
                dc.DrawBitmap(self.Img,self.Img_x[0],self.Img_y[0])
             
        else:
            dc.SetPen(wx.Pen('Brown',4))
            dc.SetBrush(wx.Brush('White'));        
            dc.SetFont(wx.Font(25, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawRoundedRectangle(100,100,700,300,20)
            dc.DrawBitmap(self.Img,150,150)
            dc.DrawText(self.P.maymin("¡Estupendo!"),500,200)
        event.Skip()
     
        
    def MJclic29(self,event):
        self.px,self.py= event.GetPosition()    
        for i in range(0,4):
            if self.px in self.bloque_x[i] and self.py in self.bloque_y[i] and not self.ampliarfoto :
                if self.eleccion[i]=='V':
                    self.eleccion[i]='F'
                else:
                    self.eleccion[i]='V'
                    
        if self.px in self.Img_x and self.py in self.Img_y:
            if self.ampliarfoto==False:
                self.ampliarfoto=True
                self.Img_x=range (100,100+600)
                self.Img_y= range (0,500)
                self.Img= self.Imga.Scale(600, 500, wx.IMAGE_QUALITY_HIGH)
                self.Img= wx.BitmapFromImage(self.Img)
                self.corregir.Hide()
            else:
                self.ampliarfoto=False
                self.Img_x= range (300,300+200)
                self.Img_y= range (10,210)
                self.Img= self.Imga.Scale(300, 200, wx.IMAGE_QUALITY_HIGH)
                self.Img= wx.BitmapFromImage(self.Img)
                self.corregir.Show()
        self.padre.Refresh()
        event.Skip()        
        
    def MainJuego29(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.Refresh()        
        event.Skip()
                
    def Apoyo29(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar29(self,event):
        
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        self.Unbind(wx.EVT_LEFT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)
        self.corregir.Destroy()
        event.Skip()

    def Ayuda29(self,event):
        self.sonido.habla(u'Elige las frases que sean verdaderas.')
        event.Skip()
        
    def Corregir29 (self,event):
        self.fallos=4
        for i in range(0,4):
            if self.eleccion[i] == self.pistas[i+1][-1::]:
                self.fallos-=1    
                
        if self.fallos==0:
            self.completada=True
            self.padre.sonido(22)
            self.P.puntos=self.P.puntos+(self.P.incremento/(self.fallos+1))
            self.padre.Panel_control.progreso.SetValue(self.P.puntos)
            self.P.puntosjuegos[29]+=1
        else:
            self.P.fallosjuegos[29]+=1
            self.padre.sonido(1)
        self.Refresh()
        event.Skip()
        
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(550,430),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir29)
        self.Img=wx.Image(self.direccion+'imagenes/120px-Play_icon.png',wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego29)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda29)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar29)  
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo29)
        self.Bind(wx.EVT_PAINT, self.PaintJuego29)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic29)
        self.SetFocus()
        self.padre.sonido(4)
        self.Refresh()    
        self.Show()
