#!/usr/bin/env python
# -*- coding: utf-8 -*-
# Katamotz Ejercicios empezó Feb/28/2011 (23:27:21) por Gonzalo Uriarte Gomez
# Copyrigth (c) 2011. Licencia GNU GPL version 3.
#
#
# Todo esto es posible gracias a:
#   1) Pictogramas CATEDU de ARASAAC (http://catedu.es/arasaac/) Autor:Sergio Palao
#   2) Motor de voz: Festival 1.96 Beta CopyRight(c) University of Edinburg 1996-2004.All rights reserverd.
#   3) Voces Pedro y Silvia : Junta de Andalucia.
#   4) Talker.py: Python + Festival API. GNU/GPL. 2003 / Gary Cramblitt
#   5) Mypexpect: Mantiene el festival a la espera de mis palabras. Noah Spurrier 2003
#   6) Imagenes:
#        Imagen modificada: "Media-playback-start.svg" Chris Down y Tango (Wiki commons)
#        Imagen original: "Reload all tabs.png" creador: Elasto. Signo de reciclaje.(Wiki commons)
#        Imagen original:  "Cross sign.png" creador: Cflm001. Signo de cruz. (Wiki commons)
#        Imagen original: "120px-Emblem-question" creador Inductiveload. Signo de interrogación.(Wiki commons)
#
#   Para más información Leer en la carpeta de Documentación y Licencias
#
# En este juego se trata de proponer unos ejercicios de lectura de pseudopalabras.
#
#

import wx
import codecs
import sys
import os
import random
import time
import copy



class ModuloJuego(wx.Panel):
    def __init__(self,Padre,Palabras,Sonido,direccion):
        wx.Panel.__init__(self, Padre, wx.ID_ANY,size=(900,520))
        self.P=Palabras
        self.padre=Padre
        self.sonido=Sonido
        self.direccion=direccion
        # tabla que recoge el numerodejuego,el tipo y el autor
        self.padre.Tabla_Ejercicios.append( [34,2,u'Gontzal Uriarte',u'Pseudopalabras'] )
        self.palabra=""
        self.fallos=0
        self.completada=False
        self.py=0;self.px=0;
        self.palabras=[]
        self.bloque_x=[]
        self.bloque_y=[]
        self.MsilabasD=[]
        self.MsilabasI=[]
        self.MsilabasT=[]
        self.MsilabasS=[]
        self.letrasSV=[]
     

    def inicializar(self):
        self.padre.tiempo.Start(5000)
        self.SetBackgroundColour('Blue')
        self.MsilabasD=[]
        self.MsilabasI=[]
        self.MsilabasT=[]
        self.MsilabasS=[]
        self.letrasSV=[]
        self.palabras=[]
        self.correcta=False
        self.completada=False
        
        for i in range(0,len(self.P.letras)):
            if not( self.P.letras[i]=='a' or self.P.letras[i]=='e' or self.P.letras[i]=='i' or self.P.letras[i]=='o' or self.P.letras[i]=='u'):
                self.letrasSV.append(self.P.letras[i])
                
        
        self.MsilabasD.append(random.choice(self.P.silabasD))
        for i in range(0, len(self.P.silabasD)):
            for j in range(0,len(self.letrasSV)):
                if self.letrasSV[j] in self.P.silabasD[i]:
                    self.MsilabasD.append(self.P.silabasD[i])
                    
        self.MsilabasI.append(random.choice(self.P.silabasI))
        for i in range(0, len(self.P.silabasI)):
            for j in range(0,len(self.letrasSV)):
                if self.letrasSV[j] in self.P.silabasI[i]:
                    self.MsilabasI.append(self.P.silabasI[i])
                    
        self.MsilabasT.append(random.choice(self.P.silabasT))
        for i in range(0, len(self.P.silabasT)):
            for j in range(0,len(self.letrasSV)):
                if self.letrasSV[j] in self.P.silabasT[i]:
                    self.MsilabasT.append(self.P.silabasT[i])
                    
        self.MsilabasS.append(random.choice(self.P.silabasS))
        for i in range(0, len(self.P.silabasS)):
            for j in range(0,len(self.letrasSV)):
                if self.letrasSV[j] in self.P.silabasS[i]:
                    self.MsilabasS.append(self.P.silabasS[i])
        
        # introducimos las sílabas 1
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasD))
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        
        # introducimos las sílabas 2
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasI))
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasI))
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        
        # introducimos las sílabas 3
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.MsilabasI)+random.choice(self.P.silabasT))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasS))
        
        # introducimos las sílabas 4
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.MsilabasI)+random.choice(self.P.silabasT))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasS))
       
        # introducimos las sílabas 5
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.MsilabasI)+random.choice(self.P.silabasT))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasS))
        
        # introducimos las sílabas 6
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.MsilabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.MsilabasI)+random.choice(self.P.silabasT)+random.choice(self.P.silabasT))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.MsilabasS)+random.choice(self.MsilabasS))
        
        # introducimos las sílabas 7
        self.palabras.append(random.choice(self.MsilabasD)+random.choice(self.P.silabasD)+random.choice(self.P.silabasD))
        self.palabras.append(random.choice(self.MsilabasI)+random.choice(self.MsilabasT)+random.choice(self.P.silabasT))
        self.palabras.append(random.choice(self.P.silabasD)+random.choice(self.P.silabasT)+random.choice(self.MsilabasS))
        
        quitar=[u'aa',u'bb',u'dd',u'ee',u'ff',u'gg',u'hh',u'ii',u'jj',u'kk',u'oo',u'pp',u'qq',u'ss',u'tt',u'uu',u'vv',u'ww',u'xx',u'yy',u'zz',u'pb',u'bp',u'pv',u'vp',u'dp']
        for i in range(0,len(self.palabras)):      
            for repeticion in quitar:
                self.palabras[i]=self.palabras[i].replace(repeticion,repeticion[0])
         
        
        self.padre.Refresh()
        
    def PaintJuego25(self,event):
        dc=wx.PaintDC(self)
        dc.SetFont(wx.Font(23, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        
        linea=0
        for i in range (0,21,3):
            dc.DrawText(self.palabras[i],50,50+50*linea)
            dc.DrawText(self.palabras[i+1],350,50+50*linea)
            dc.DrawText(self.palabras[i+2],650,50+50*linea)
            linea+=1
    
        event.Skip()
     

    def MJclic25(self,event):
        self.px,self.py= event.GetPosition()    
        
        event.Skip()        
        
    def MainJuego25(self,event):
        self.inicializar()
        self.padre.sonido(4)
        self.padre.Refresh()        
        event.Skip()
                
    def Apoyo25(self,event):
        self.px,self.py= event.GetPosition()
        event.Skip()
        
    def Terminar25(self,event):
        
        self.corregir.Destroy()
        self.padre.tiempo.Stop()
        self.padre.tiempo.Destroy()
        self.padre.Panel_control.Repetir.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Ayudame.Unbind(wx.EVT_BUTTON)
        self.padre.Panel_control.Terminar.Unbind(wx.EVT_BUTTON)  
        
        self.Unbind (wx.EVT_RIGHT_DOWN)
        self.Unbind(wx.EVT_PAINT)
        self.Unbind (wx.EVT_LEFT_DOWN)
        
        self.Hide()
        self.padre.pantalla=1 # 1:pantalla de ejercicios
        self.padre.Panel_ejercicios.Show()
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.padre.onclose)       
        event.Skip()
        
    def ontimer(self,event):
        
        event.Skip()

    def Ayuda25(self,event):
        self.sonido.habla(u'Lee estas palabras que no significan nada.')
        event.Skip()
        
    def Corregir25 (self,event):
        
        event.Skip()
        
    def Juego(self):
        self.corregir=wx.Button (id=wx.NewId(),label=u'Corregir',name="Corregir" , parent=self, pos=wx.Point(350,420),size=wx.Size(145,50),style=0)
        self.corregir.Bind(wx.EVT_BUTTON,self.Corregir25)
        self.Img=wx.Image(self.direccion+'imagenes//120px-Play_icon.png',wx.BITMAP_TYPE_ANY)
        self.Img= self.Img.Scale(100, 100, wx.IMAGE_QUALITY_HIGH)
        self.Img= wx.BitmapFromImage(self.Img)
        
        self.inicializar()
        self.padre.Panel_control.Repetir.Bind(wx.EVT_BUTTON,self.MainJuego25)
        self.padre.Panel_control.Ayudame.Bind(wx.EVT_BUTTON,self.Ayuda25)
        self.padre.Panel_control.Terminar.Bind(wx.EVT_BUTTON,self.Terminar25)  
        
        self.Bind (wx.EVT_RIGHT_DOWN,self.Apoyo25)
        self.Bind (wx.EVT_PAINT, self.PaintJuego25)
        self.Bind (wx.EVT_LEFT_DOWN,self.MJclic25)
        
        self.padre.sonido(4)
        self.Refresh()    
        self.Show()
