#!/usr/bin/env python
# -*- coding: utf-8 -*-


import wx
import glob
import codecs
import os


class Contrasena(wx.Panel):
    def __init__(self, parent,P,direccion,direccionAlumnos):
        wx.Panel.__init__(self, parent, wx.ID_ANY,size=(1200,520))

        self.Hide()
        self.SetSize((1200,500))
        self.SetPosition((0,0))
        
        self.soymaestra=False
        self.contrasena=[0,0,0]
        self.padre=parent 
        self.P=P
        self.padre.SetBackgroundColour('blue')
        self.direccionAlumnos=direccionAlumnos
        self.direccion=direccion
        
        self.Img_Terminar=wx.Image(self.direccion+'imagenes//Terminar.png',wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        


        # cargamos las imagenes de la contrasena
        self.img=[]
        self.animal=[]
        self.figura=[]
        for i in range(1,4):
            self.imagen= wx.Image(self.direccion+'imagenes//contrasena'+str(i)+".png", wx.BITMAP_TYPE_ANY)
            self.img.append(wx.BitmapFromImage(self.imagen))            
        
        for i in range(0,6):
            self.imagen= wx.Image(self.direccion+'imagenes//Animal'+str(i)+".png", wx.BITMAP_TYPE_ANY)
            self.imagen= self.imagen.Scale (65, 65, wx.IMAGE_QUALITY_HIGH)
            self.animal.append(wx.BitmapFromImage(self.imagen))            
        
        for i in range(0,6):
            self.imagen= wx.Image(self.direccion+'imagenes//Figura'+str(i)+".png", wx.BITMAP_TYPE_ANY)
            self.imagen= self.imagen.Scale (65, 65, wx.IMAGE_QUALITY_HIGH)
            self.figura.append(wx.BitmapFromImage(self.imagen))            
        
        # Creando los cuadros sensibles al clic de ratón de las zonas 
        #amarillas de los mandos de la contraseña para cambiar los dibujos.
        self.Cuadro_x=[]
        self.Cuadro_y=[]
        for i in range(0,3):
            self.Cuadro_x.append(range(150*i+300,150*i+390))
        self.Cuadro_y.append (range(150,190))
        self.Cuadro_y.append (range(260,300))
        
        
        self.imagen= wx.Image(self.direccion+'imagenes//maestra.png', wx.BITMAP_TYPE_ANY)
        self.imagen= self.imagen.Scale (70, 70, wx.IMAGE_QUALITY_HIGH)
        self.maestra=wx.BitmapFromImage(self.imagen)           
        
                
        self.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        self.SetBackgroundColour('blue')
        self.SetForegroundColour("Black")
        self.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
        self.Nombre=wx.TextCtrl(id=wx.NewId(),name='Nombre',parent=self,pos=wx.Point(280,35),size=wx.Size(425,60), style=wx.TE_PROCESS_ENTER,value='')
        
        self.Texto1=wx.StaticText(self,-1,u"¿Quién eres?",(20,50),(250,100),wx.ALIGN_LEFT)
        self.Texto2=wx.StaticText(self,-1,u"Contraseña:",(20,200),(250,100),wx.ALIGN_LEFT)   
        self.Botonmaestra= wx.BitmapButton(self,-1,self.maestra,(800,20),(80,80),wx.BITMAP_TYPE_ANY)
        self.Botonmaestra.Bind (wx.EVT_BUTTON,self.contrasenamaestra)
        self.Terminar=wx.BitmapButton(self,-1,self.Img_Terminar,(890, 20),(80,80),wx.BITMAP_TYPE_ANY)        
        self.Terminar.Bind (wx.EVT_BUTTON,self.padre.onclose)
        self.Bind (wx.EVT_PAINT,self.dibujacontrasena)
        self.Bind (wx.EVT_LEFT_DOWN,self.motorcontrasena)
        self.Login=wx.Button ( id=wx.NewId(),label=u'Entrar',name="Anadir" , parent=self, pos=wx.Point(100,350),size=wx.Size(200,70),style=0)
        self.Login.SetBackgroundColour((0,0,200))
        self.Login.SetForegroundColour("White")
        self.Nueva=wx.Button ( id=wx.NewId(),label=u'Crear Alumno',name="Nuevo" , parent=self, pos=wx.Point(350,350),size=wx.Size(370,70),style=0)
        self.Nueva.SetForegroundColour("White")
        self.Nueva.SetBackgroundColour((20,120,200))
    
        self.Bind(wx.EVT_BUTTON,self.onLogin,self.Login)
        self.Bind(wx.EVT_TEXT_ENTER,self.onLogin,self.Nombre)
        self.Bind(wx.EVT_BUTTON,self.crea_alumno,self.Nueva)
        self.Nombre.SetFocus()
        self.Bind (wx.EVT_PAINT,self.dibujacontrasena)
        
        
        
    
        
    def dibujacontrasena (self,event): # dibuja la contraseña si soy alumno. Si soy maestra no habrá este tipo de contraseña
        dc=wx.PaintDC(self)
        if not self.soymaestra:
            for i in range(0,3):
                dc.DrawBitmap(self.img[i],150*i+270,150,False)
            dc.SetFont(wx.Font(60, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            dc.DrawText (str(self.contrasena[0]),325,185)
            dc.DrawBitmap(self.animal[self.contrasena[1]],150+310,188,False)
            dc.DrawBitmap(self.figura[self.contrasena[2]],300+310,188,False) 
        event.Skip()

    
    def motorcontrasena(self,event): # desde aqui controlaremos los clics que se hacen en la pantalla para cambiar la contraseña.
        px,py= event.GetPosition()
        x=-1
        y=-1
        for i in range (0,3):
            if px in self.Cuadro_x[i]:
                x=i
            
        for i in range (0,2):
            if py in self.Cuadro_y[i]:
                y=i
        
        if x in range(0,3):
            if y==0: # El amarillo de arriba
                if self.contrasena[x]<5: self.contrasena[x]+=1
                else: self.contrasena[x]=0
            if y==1 : #El amarillo de abajo
                if self.contrasena[x]>0: self.contrasena[x]-=1
                else: self.contrasena[x]=5
        self.Refresh()
        event.Skip()
    
        
    
        
        
        
    def contrasenamaestra(self,event):#cambia la pantalla dependiendo del usuario despues de haber pulsado el boton de maestra
        if self.soymaestra: # soy maestra y cambio a alumno
            self.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            self.Nueva=wx.Button ( id=wx.NewId(),label=u'Crear Alumno',name="Nuevo" , parent=self, pos=wx.Point(350,350),size=wx.Size(370,70),style=0)
            self.Nueva.SetForegroundColour("White")
            self.Nueva.SetBackgroundColour("Blue")
            self.soymaestra= False
            self.Texto2.Destroy()
            self.Texto1=wx.StaticText(self,-1,u"¿Quién eres?",(20,50),(240,100),wx.ALIGN_LEFT)
            self.Texto2=wx.StaticText(self,-1,u"Contraseña:",(20,200),(240,100),wx.ALIGN_LEFT)
            self.Nombre.Destroy()
            self.Nombre=wx.TextCtrl(id=wx.NewId(),name='Nombre',parent=self,pos=wx.Point(280,35),size=wx.Size(425,60), style=wx.TE_PROCESS_ENTER,value='')
            self.Nombre.SetFocus()
            
        else:# soy alumno y cambio de usuario a maestra activando controles alumno
            
            self.Nueva.Destroy()
            self.Nombre.Destroy()
            self.SetFont(wx.Font(30, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "Edelfontmed")) 
            self.Nombre=wx.TextCtrl(id=wx.NewId(),name='Nombre',parent=self,pos=wx.Point(280,35),size=wx.Size(425,60), style=wx.TE_PROCESS_ENTER | wx.TE_PASSWORD ,value='') 
            self.soymaestra= True
            self.Texto1.Destroy()
            self.Texto2.Destroy()     
            self.Texto2=wx.StaticText(self,-1,u"Contraseña:",(20,50),(240,100),wx.ALIGN_LEFT)            
            self.Texto1=wx.StaticText(self,-1,"",(20,250),(270,100),wx.ALIGN_LEFT)
            self.Texto1.Hide()
            self.Nombre.SetFocus()
            
        self.Refresh()
        event.Skip()
        
    
    def crea_alumno(self,event):#crea un alumno.
        try:
            self.Nombre.SetValue(self.Nombre.GetValue().replace(" ","")) #Eliminados todos los espacios en blanco
            self.P.contrasenaALUMNOstr=str(self.contrasena[0])+str(self.contrasena[1])+str(self.contrasena[2])
            # controlar que el alumno no exista anteriormente
            fcoinciden= glob.glob(self.direccionAlumnos+'//'+self.Nombre.GetValue().lower()+'.*')
            if len(fcoinciden)==0 and self.Nombre.GetValue()!='':
                archivo=codecs.open(self.direccionAlumnos+'//'+self.Nombre.GetValue().lower()+'.'+self.P.contrasenaALUMNOstr,'w','utf-8')
                archivo.write('a-e-i-o-u\n') # dificultades
                archivo.write('0-0-0-0-0\n') # puntos según dificultades
                archivo.write('0-0-0-0-0\n') # fallos según dificultades
                cadena="0"
                for i in range(0,self.padre.N_Ejercicios-1):
                    cadena=cadena+'-0'
                archivo.write(cadena+'\n') # puntos en Juegos
                archivo.write(cadena+'\n') # fallos en Juegos
                archivo.write('100\n')
                archivo.write('10\n')
                self.P.puntuacionmaxima=100
                self.P.incremento=10
                archivo.close ()
                m=wx.MessageBox ('Alumno creado correctamente','Info')
            else:
                if self.Nombre.GetValue()=='':
                    m=wx.MessageBox ('Introduzca algún usuario válido','Info')
                else:
                    m=wx.MessageBox ('Ya existe ese usuario','Info')
        except:
            m=wx.MessageBox ('Error fatal. No se pudo crear usuario','Info')
        
            
        event.Skip()
            
    def onLogin(self,event): #la contraseña es valida entonces carga el programa
        entrando= True
        self.Nombre.SetValue(self.Nombre.GetValue().replace(" ","")) #Eliminados todos los espacios en blanco
        if self.soymaestra:#si soy maestro            
            try:
                self.P.nombrealumno = ''
                self.padre.Herramientas2.Enable(True)
                self.padre.Herramientas.Enable(True) # Como soy maestra mostraré las herramientas
                archivo=codecs.open(self.direccion+'maisu.psw','r','utf-8')
                contrasenamaestro=archivo.readline()        
                a=str(contrasenamaestro)
                b=self.Nombre.GetValue().lower()
                if a[0:-1:] != b : #la contraseña no es valida 
                    entrando=False
                    m=wx.MessageBox (u'Constraseña no valida','Info')
                else:
                    self.P.contrasenaMAESTRO=a[0:-1:]
                    self.Nombre.SetValue('')
            except:
                entrando=False
                m=wx.MessageBox (u'Error en archivo de contraseña','Info')    
        else: # si soy alumna
            
            self.padre.Herramientas2.Enable(True)
            self.padre.Herramientas.Enable(False) # Como soy alumno no mostrare las herramientas
            try:
                archivo=codecs.open(self.direccionAlumnos+'//'+self.Nombre.GetValue().lower()+'.'+str(self.contrasena[0])+str(self.contrasena[1])+str(self.contrasena[2]),'r','utf-8')
                try:

                    # saca las letras-dificultades 
                    linea0= archivo.readline().replace("\n","")
                    self.P.dificultades=linea0.split('-')
                    
                    # saca los puntos por letra y conviertelos en números enteros.
                    linea01= archivo.readline().replace("\n","")
                    self.P.puntosletras=linea01.split('-')
                    self.P.puntosletras = [float(n) for n in self.P.puntosletras]
                    
                    # saca los fallos por letra y conviertelos en números enteros.
                    linea02= archivo.readline().replace("\n","")
                    self.P.fallosletras=linea02.split('-')
                    self.P.fallosletras = [float(n) for n in self.P.fallosletras]
                    
                    # saca los puntos por ejercicio y conviertelos en números enteros.
                    linea03= archivo.readline().replace("\n","")
                    lista03 =linea03.split('-')
                    for i in range (0,len(lista03)):
                        self.P.puntosjuegos[i]=float (lista03[i])
                    
                    # saca los fallos por ejercicio y conviertelos en números enteros.
                    linea04= archivo.readline().replace("\n","")
                    lista04=linea04.split('-')
                    for i in range (0,len(lista04)):
                        self.P.fallosjuegos[i]=float(lista04[i])
                    
                    linea1= archivo.readline()
                    self.P.puntuacionmaxima= int(linea1.replace("\n",""))
                    
                    linea2= archivo.readline()
                    self.P.incremento= int(linea2.replace("\n",""))
                    archivo.close()
                    self.P.nombrealumno = self.Nombre.GetValue().lower()
                    self.P.contrasenaALUMNOstr = str(self.contrasena[0])+str(self.contrasena[1])+str(self.contrasena[2])
                
                    
       
                except:
                    m=wx.MessageBox ('Error leyendo archivo de dificultades','Info')
            except:
                m=wx.MessageBox ('No encontramos este usuario: '+self.direccionAlumnos+'//'+self.Nombre.GetValue().lower()+'.'+str(self.contrasena[0])+str(self.contrasena[1])+str(self.contrasena[2]) + ' /n Intentalo de nuevo','Info')
                entrando=False
                
        
        if entrando: # si las contraseñas se han dado debidamente. comienza el programa
            self.padre.pantalla=0
            self.padre.configurapantalla()
            
